/* alg_md2.h - Access Header for OSISEC-conformant implementation of MD2 */

#ifndef _OSISEC_MD2_DEFINED_
#define _OSISEC_MD2_DEFINED_


/* MD2 does not have any parameters */

struct MD2Hash {
  char D[16];
  char C[16];
  int  L;
};
#define NULLMD2HASH ((struct MD2Hash *)0)

struct MD2Key;
struct MD2Parameters;

extern int md2_hash_block();
extern int md2_hash_short_block();
extern int md2_init_hash();
extern int md2_terminate_hash();
extern int md2_pack_hash();
extern int md2_unpack_hash();
extern int md2_get_blocksize();
extern int md2_get_hashsize();
extern int md2_compare_hash();
extern int md2_free_hash();

#define MD2HASHALGORITHMVALUE { \
	"md2", \
	md2_hash_block, \
	md2_hash_short_block, \
	md2_init_hash, \
	md2_terminate_hash, \
	md2_pack_hash, \
	md2_unpack_hash, \
	md2_get_blocksize, \
	md2_get_hashsize, \
	md2_compare_hash, \
	md2_free_hash \
}

extern struct HashAlgorithm	*use_hash_md2();

#ifndef _MD2WITHRSA_
#define _MD2WITHRSA_
extern struct SignatureAlgorithm md2withrsa_sig_alg;
extern struct SignatureAlgorithm* use_sig_md2withrsa();
#endif

#endif
#ifdef SOLARIS
#include <string.h>
#define bcopy(b1,b2,l)  memmove(b2,b1, (size_t)(l))
#define bzero(b,l)      memset(b, 0, (size_t)(l))
#define bcmp(b1,b2,l)   memcmp(b1,b2, (size_t)(l))
#define srandom(s)      srand48((long)s)
#define random()        lrand48()
#endif

