/* testmd.c */

#include <stdio.h>
#include "alg_md2.h"

main()
{
	char buf[10000], c;
	int i;
	
	while((c = getchar()) != EOF){
		buf[i++] = c;
		}
	md2test(buf, i);
	return 0;
}

md2test(text, len)
char text[];
int len;
{

	struct MD2Hash *hash;
/*	char		*text = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"; */
	char            buff[16];
/*	int             len;*/
	int             i;
	int             blocks;
	int		extra;

/*	hlen = strlen(text);*/

	(void)printf("MD2: %s\nMessage length = %d\n", text, len);

	blocks = len / 16;
	extra = len % 16;
	(void)printf("%d blocks, %d extra\n", blocks, extra);

	(void)md2_init_hash(&hash, (struct MD2Parameters*)NULL, (struct MD2Key *)NULL);

	for (i = 0; i < blocks; i++)
		(void)md2_hash_block(hash, text+i*16, (struct MD2Key *)NULL, (struct MD2Parameters *)NULL);

	bcopy(text+blocks*16, buff, extra);
	bzero(buff+extra, 16 - extra);
	(void)md2_hash_short_block(hash, buff, extra, (struct MD2Key *)NULL, (struct MD2Parameters *)NULL);
	(void)md2_terminate_hash(hash, (struct MD2Key *)NULL, (struct MD2Parameters *)NULL);
	(void)md2_display(hash);
}

md4test()
{
	struct MD4Hash *hash;
	char		*text = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	char            buff[64];
	int             len;
	int             i;
	int             blocks;
	int		extra;

	len = strlen(text);

	(void)printf("MD4: %s\nMessage length = %d\n", text, len);

	blocks = len / 64;
	extra = len % 64;
	(void)printf("%d blocks, %d extra\n", blocks, extra);

	(void)md4_init_hash(&hash, (struct MD4Parameters*)NULL, (struct MD4Key *)NULL);

	for (i = 0; i < blocks; i++)
		(void)md4_hash_block(hash, text+i*16, (struct MD4Key *)NULL, (struct MD4Parameters *)NULL);

	bcopy(text+blocks*64, buff, extra);
	bzero(buff+extra, 64 - extra);
	(void)md4_hash_short_block(hash, buff, extra, (struct MD4Key *)NULL, (struct MD4Parameters *)NULL);
	(void)md4_terminate_hash(hash, (struct MD4Key *)NULL, (struct MD4Parameters *)NULL);
	(void)md4_display(hash);
}

md5test()
{
	struct MD5Hash *hash;
	char		*text = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	char            buff[64];
	int             len;
	int             i;
	int             blocks;
	int		extra;

	len = strlen(text);

	(void)printf("MD5: %s\nMessage length = %d\n", text, len);

	blocks = len / 64;
	extra = len % 64;
	(void)printf("%d blocks, %d extra\n", blocks, extra);

	(void)md5_init_hash(&hash, (struct MD5Parameters*)NULL, (struct MD5Key *)NULL);

	for (i = 0; i < blocks; i++)
		(void)md5_hash_block(hash, text+i*16, (struct MD5Key *)NULL, (struct MD5Parameters *)NULL);

	bcopy(text+blocks*64, buff, extra);
	bzero(buff+extra, 64 - extra);
	(void)md5_hash_short_block(hash, buff, extra, (struct MD5Key *)NULL, (struct MD5Parameters *)NULL);
	(void)md5_terminate_hash(hash, (struct MD5Key *)NULL, (struct MD5Parameters *)NULL);
	(void)md5_display(hash);
}

