/* numalgs.h - implementation of a various numerical algorithms relevant to cryptography */

#ifndef _OSISEC_NUMALGS_DEFINED_
#define _OSISEC_NUMALGS_DEFINED_

#define BITS 16			/* Number of bits per word    */
#define LSW  0			/* Least significant word     */
#define NPW  4			/* Nibbles per word           */
#define MASK 65535		/* Mask out unused bits       */
#define HNIB 12			/* Shift high nibble down     */
#define TOPB 32768		/* Highest bit in word        */

extern void     copy();
extern void     clear();
extern int      add();
extern unsigned adn();
extern int      ads();
extern int      sub();
extern int      sbl();
extern int      sbn();
extern int      sbs();
extern int      shl();
extern void     reduce();
extern void     fullreduce();
extern void     multiply();
extern void     tablemul();
extern void     modmul();
extern void     modexp();
extern void     fermatexp();
extern void     fastexp();
extern void     smallexp();
extern int      bitsfree();
extern void     bsl();
extern void     bsr();

extern void     hexdump();
extern void     fhexdump();

extern void     chexp();

extern int      trialdiv();
extern int      primesieve();
extern void     prime();
extern void     strongprime();
extern int      pptest();
extern void     rsaparms();

#endif
