#!/bin/sh
#
# Script to test whether the Generated keys are "good" and
# different.   
#
#     "No two keys ought to share a P or a Q in common."
#
# If you feed the output to /bin/sh you can get rid of the dubious files 
# at the same time.
#

OSISECTAILOR=/iso/etc/osisec/osisectailor

if [ -f $HOME/.authrc ]
then
	hdir=$HOME/.authrc
fi

dir=`awk ' $1 == "key_directory:" { dir = $2 } \
	END { print dir }' $OSISECTAILOR $hdir`
cd $dir

awk ' BEGIN {
	ignore = ""
	procfiles = 0
	okfiles = 0 }
$1 == "P" { 
	procfiles ++
	if ( ! primeP [ $3 ] ) { 
		primeP [ $3 ] = FILENAME 
	} else { 
		printf "# Problem duplicate %s line in files %s and %s\n", $1, primeP [ $3 ], FILENAME 
		print "rm -f " FILENAME
		ignore = FILENAME
	} }
$1 == "Q" { 
	if ( ! primeQ [ $3 ] ) { 
		primeQ [ $3 ] = FILENAME 
		if ( FILENAME != ignore ) {
			okfiles ++
		}
	} else  if ( FILENAME != ignore ) {
		printf "# Problem duplicate %s line in files %s and %s\n", $1, primeQ [ $3 ], FILENAME 
		print "rm -f " FILENAME
		}
	} 
END { print "# " okfiles "/" procfiles " generated keys are probably unique here"
	}' `/bin/ls -1 | grep 'rsa#' | sort -t'#' -n +1`
