static char *rev="$Header: RCS/qv.c 1.10 91/10/06 19:46:27 TAMOYAN Exp $";
#define VER "version 1.10"
#define TITLE "\nQuick-VAN %s (C) 1989-1991 KAISER, TAMOYAN, paku & s.kasai\n                      +unix 0.10 (C) 1991-1992 T.Matsui\n"

#define MAIN
#include "qv.h"
#include "qvmsg.h"
#include	<signal.h>
#include	<setjmp.h>

static	char	FileList = 'n' ;

/*---------------------*/
/*  gp@̕\     */
/*---------------------*/
static usage()
{	fprintf(stderr, TITLE, VER);
	fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s%s%s",
		"Usage: qv [options] [filenames|path]\n",
		"options are\n",
		"-s     : Send files.    (User to host)\n",
		"-r     : Receive files. (Host to user)\n",
		"-b[n]  : Set Real (modem-to-modem) BPS.\n",
		"-w[n]  : Set window size. (1..30,default 20)\n",
		"-o     : Overwrite files if exist.\n",
		"-a     : Append files if exist.\n",
		"-c     : Cancel files if exist.\n",
		"-g     : Display transfer status by graph.\n",
		"-fDIR  : Upload & Download default directory.\n",
		"-n     : Send start without waiting <NAK>.\n",
		"-@     : Specify file name list.\n"
	);
	exit(1);
}
/* SLW */
/*----------------------------------------*/
/*  Ot@CEfBNg̃`FbN  */
/*----------------------------------------*/
static logdirset(dir)
char *dir; 
{
	struct stat 	Ftype ;
	int				len   ;
	char			path[128] ;

	strcpy(logdir,"") ;
	strcpy(path,dir) ;
	if ( CheckPathname(path) != NORMAL )  exit(1) ;
	if ( debug != 'y' ) debug = 'l' ;
	strcpy(logdir,path) ;
	return ;
}
/*----------------------------------------*/
/*  t^cfBNg̃`FbN  */
/*----------------------------------------*/
static udldirset(dir)
char *dir; 
{
	struct stat 	Ftype ;
	int				len   ;
	char			path[256] ;

	strcpy(udldir,"") ;
	strcpy(path,dir) ;
	if ( CheckPathname(path) != NORMAL )  exit(1) ;
	strcpy(udldir,path) ;
	return ;
}
/*----------------------------*/
/*  lp[^̃`FbN  */
/*----------------------------*/
static numset(s, min, max, def)
char *s;
int min;
int max;
int def;	/* set numeric number */
{	int n;
	n=atoi(s);
	if ((n>max)||(n<min)) n=def;
	return n;
}

/*-----------------------------------------*/
/*  t@C̃ChEJ[h̓WJ     */
/*-----------------------------------------*/
static WildNames(count, wild)
	int 	*count ;
 	char  ***wild ;
{
#define	MAXPATH		128		/* about... */
#define	MaxArgSz    1024
#define	MaxArgNm    128
			int		n , i , sts	, m ;
			char*	p			;
			char**  v			;
			char    pathname[256] 		;
	static 	char*	files[MaxArgNm] 	;
	static  char	fnames[MaxArgSz]	;
            char    drive[4] 	;
			char	dir[64]		;
			char    name[9]		;
			char	ext[5]		;
			char    dmy[16]		;
			FILE*	fp			;

    v = *wild ;
	i = m = 0  ;
	p = fnames ;
	for ( n = 0 ;
	    ( n < *count) && (i < MaxArgSz-MAXPATH) && (m < MaxArgNm);
	      n++ )
	{
		if (udldir[0] != '\0')
			sprintf( pathname, "%s/%s", udldir, v[n] );
		else
			strcpy(pathname,v[n]) ;
		if ( FileList == 'y' && (fp = fopen(pathname,"r")) != NULL) {
			while( (fgets( dir, 96, fp) !=NULL) && 
				   (i < MaxArgSz-MAXPATH)       && 
				   (m < MaxArgNm) )
			{
				if ( (sts = strlen( dir) - 1) >= 0 && dir[sts] == '\n') {
					dir[sts] = '\0';
				}
				if ( strlen( dir) > 0 )	{
					strcpy( p, dir);
					files[m++] = p;
					i += strlen( dir) + 1;
					p = &fnames[i];
				}
			}
			fclose( fp);
		}else{
			strcpy( p, pathname );
			files[m++] = p ;
			i += strlen(p) + 1 ;
			p = &fnames[i] ;
    	}
	}
    *count = m ;
	*wild = files ;
	return ;
}

/*---------------------------------------------*/
/*  QV.CFG L΁A                          */
/*  sIvV̈Öْlݒ肷         */
/*                                             */
/*---------------------------------------------*/
static void GetConfig(exec)
	char*	exec	;/*(I) EXE file fullpath name */
{
	char*	QV_cfg  = "qv.cfg" ;
	FILE*	config 			;
	char	cfgfile[128] 	;
	char	opt[BUFSIZ] 	;
	char   *s	, *p		;

	if ( (config = fopen(QV_cfg,"r")) == NULL ) {
		strcpy(cfgfile,exec) ;
		s = rindex(cfgfile,'/') ;
		if ( s != NULL ) {
			strcpy(s+1,QV_cfg) ;
			config = fopen(cfgfile,"r") ;
		}
	}
	if ( config != NULL ) {
		while ( fgets(opt,BUFSIZ,config) != NULL ) {
			if ( opt[0] == '#' )  continue ;
			if ( opt[strlen(opt)-1] == '\n' ) {
				opt[strlen(opt)-1] = '\0' ;
			}
			for ( s = opt ; *s == ' ' ; ) s++ ;
			while ( *s ) {
				if ( *s++ == '-' ) {
					for ( p = s ; *p != ' ' && *p != '\0' ; p++) ;
					if ( *p != '\0' ) *p++ = '\0' ;
					switch(tolower(*s++)) {
						case 'b': rs_bps=atol(s); break;
						case 'w': WindowSizeMax=numset(s,1,30,20); break;
						case 'o': FileMode='O'; break;
						case 'a': FileMode='A'; break;
						case 'c': FileMode='C'; break;
						case 'd': debug='y'; break;
						case 'l': logdirset(s) ; break ;
						case 'g': gopt = 1 ; break ;
						case 'f': udldirset(s) ; break ;
						case 'n': nopt = 1 ; break ;
						default : 
							ErrorLog(E_QVCFG,s-1) ;
					}
					s = p ;
				}else{
					ErrorLog(E_QVCFG,s-1) ;
					while ( *s != ' ' ) s++ ;
				}
				while ( *s == ' ' ) s++ ;
			}
		}
		fclose(config) ;
	}
}

/*---------------------------------*/
/*  CTRL+C 荞݃[`        */
/*---------------------------------*/
static uchar   inquit='n';
static jmp_buf quit_jump ;
static quit()
{
	longjmp(quit_jump,1) ;
}
/* SLW */
/*---------------------------*/
/*  C[`           */
/*---------------------------*/

int main(argc, argv)
int argc;
char *argv[];
{	char 	mode='r';
	int 	i;
	int 	err_code;
	uchar 	file_name[80];
	char  **files ;

	if (argc<2) usage();                /* exit in usage() */
	{	char *s;
		GetConfig(argv[0]) ;/* qv.cfg IvV̈Öْlo */
		file_name[0]=0;
		for(i=1;i<argc;i++)	{
			s=argv[i];
			if (*s=='-') {
				s++;
				switch(tolower(*s++))
				{	case 's': mode='s'; break;
					case 'r': mode='r'; break;
					case 'b': rs_bps=atol(s); break;
					case 'w': WindowSizeMax=numset(s,1,30,20); break;
					case 'o': FileMode='O'; break;
					case 'a': FileMode='A'; break;
					case 'c': FileMode='C'; break;
					case 'n': nopt = 1    ; break;
					case 'd': if ( *s != '-' ) {
					              debug = 'y' ;
					          }else{
							      if ( debug == 'y' ) debug = 'n' ;
					              s++ ;
					          }
					          break;
					case 'l': if ( *s != '-' ) {
					              logdirset(s) ;
					          }else{
					              if ( debug == 'l' ) debug = 'n' ;
					              s++ ;
					          }
					          break ;
					case 'g': if ( *s != '-' ) {
					              gopt = 1 ;
					          }else{
					              gopt = 0 ;
					              s++ ;
					          }
					          break ;
					case 'f': if ( *s != '-' ) {
								  udldirset(s) ;
						      }else{
						          strcpy(udldir,"") ;
						      }
						      break ;
					case '@': FileList = 'y' ;break;
					default : usage();
				}
			}else{
				while(*s==' ') s++;
				strcpy(file_name,s);
				break ;
			}
		}
	}
	if ( cominit( &rs_bps) == 0)
	{
		if ( setjmp(quit_jump) != 0 ) {
			while( txlen() != 0 ) ;
			SendCtrl(CAN) ;
			fprintf(stderr, "User break!\n");
			comquit() ;
			exit(1) ;
		}
		if (signal(SIGHUP, SIG_IGN) != SIG_IGN)
			signal(SIGHUP, quit);
		if (signal(SIGINT, SIG_IGN) != SIG_IGN)
			signal(SIGINT, quit);
		if (signal(SIGQUIT, SIG_IGN) != SIG_IGN)
			signal(SIGQUIT, quit);
		if (signal(SIGTERM, SIG_IGN) != SIG_IGN)
			signal(SIGTERM, quit);
		fprintf(stderr, TITLE, VER);
		fputc('\n', stderr);	/* one more linefeed */
		switch(mode) {
		case 's': 
			argc -= i ; files = &argv[i] ;
			WildNames(&argc,&files) ;
			err_code=qv_send(argc,files); 
			comput(CR) ;
			break;
		case 'r': 
			err_code=qv_recieve(file_name[0]==0?udldir:file_name) ; 
			break;
		}
		comquit();
	}else{
		ErrorLog(E_ComOption) ;
		err_code = FATAL ;
	}
	return err_code;
}
/* SLW */
