/*
ALL Rights Reserved, Copyright(c)FUJITSU LABORATORIES LTD. 1995
Privacy Enhanced Telnet

			 PERMISSION NOTICE
			 -----------------
			Wed, Dec 27th, 1995

		    FUJITSU LABORATORIES LTD.
  1015 Kamikodanaka, Nakahara-ku, Kawasaki-shi, Kanagawa-ken 211, Japan

Permission to use, copy, modify and distribute this Software (including its
relevand documentation) is hereby granted without fee under the
following terms and conditions:

1. Both of copyright notices in this Software and this permission
notice shall be duplicated in copies and modification of all or a part 
of this Software.

2. This Software may be used for the profit-making purposes, provided
that sale of this Software, whether incorporated in other products as
a part thereof or not, is prohibited and that the name FUJITSU
LABORATORIES LTD. may not be used externally in relation with the use
for such profit-making purposes without specific prior written
permission.

3. On publication or presentation in any form, of the results obtained 
by use of this Software, an explicit reference to this Software and
its copyright owner shall be made.

4. THIS SOFTWARE IS PROVIDED ``AS IS" AND FUJITSU LABORATORIES
LTD. MAKES NO WARRANTIES, EITHER EXPRESSED OR IMPLIED, AS TO ANY
MATTER WHATSOEVER REGARDING TO THIS SOFTWARE, INCLUDING, WITHOUT
LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
PARTICULAR PUPRPOSE.
IN NO EVENT SHALL FUJITSU LABORATORIES LTD. BE LIABLE FOR ANY CLAIM
FROM A THIRD PARTY, OR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
ARISING OUT OF OR IN CONNECTION WITH THE USE, COPYING, MODIFICATION OR 
DISTRIBUTION OF THIS SOFTWARE.

5. this Software includes the following free software, and such free
software shall be used in accordance with the permission notices
attached to each such free software:


MANE OF FREE SOFTWARE	NAME OF DIRECTORY	NAME OF COPYRIGHT OWNER
UCB Telnet              telnet			UCB (1)        
UCB Telnetd             telnetd			UCB            
UCB libtelnet           libtelnet		UCB            
GNU DES Libray          DES			Eric Young     
OSISEC RSA Libray       RSA			Peter Williams 
OSISEC MD Libray        MD			Peter Williams 
transit		        transit			ASCII Corporation
bplus               	bplus			K.Suzuki(katsu@wide.ad.jp)
						T.Taniguchi(tani@wide.ad.jp)
zmodem              	zmodem			Omen Technology Inc.
telnetx                 telnet/telnetx.c	UEC (2)      

PET3 Library            pet			FUJITSU LABORATORIES LTD.

	(1) UCB: The University of California, Berkeley School
	(2) UEC: The University of Electro-Communications



*/
/* $Id: berlib.c,v 1.5 1996/02/07 01:14:29 kuroda Exp $ */

#include	<stdio.h>
#ifndef	_HAVE_NO_MALLOC_H_
#include	<malloc.h>
#endif
#include "pet2.h"
#include	"cert.h"
#include	"rsa.h"

#define	BSIZE	1024
#define	SEQSIZE	64


/*
typedef	struct{
		unsigned char	type;
		int		len;
		int		byte;
		unsigned char	*val;
	} BER;
*/

unsigned char	OID[][16] = {
	{0},
	{0x55, 0x04, 0x06, 0},
	{0x55, 0x04, 0x0a, 0},
	{0x55, 0x04, 0x0b, 0},
	{0x55, 0x04, 0x03, 0},
	{0x2a, 0x86, 0x48, 0x86, 0xf7, 0xd, 1, 1,1, 0},
	{0x55, 0x08, 1, 1, 0},
	{0x2a, 0x86, 0x48, 0x86, 0xf7, 0xd, 1, 1,2, 0},
	{0x2b, 0x0e, 0x07, 2, 3, 1, 0},
	{0x55, 0x04, 0x0c, 0},
	{0x55, 0x04, 0x07, 0},
	{0x55, 0x04, 0x05, 0},
	{0x2a, 0x86, 0x48, 0x86, 0xf7, 0xd, 1, 9, 1, 0},
	{0x9,  0x89, 0x26, 0x89, 0x93, 0xf2, 0x2c, 64, 1, 3, 0},
	{0}
};

char *OIDstr[] = {
	"Never heard of OID",
	"C", "O", "OU", "CN", 
	"rsaEncryption",
	"rsa",
	"md2WithRSAEncryption",
	"md2WithRSA",
	"title",
	"locarityName",
	"serialNumber",
	"emailAddress", 	/* 12 */
	"rfc822Mailbox" 	/* 13 */
};

char	*getmail(ber)
BER	*ber;
{
	int	i, j, oid;
	BER	*ip, *jp;

	for(i = 0; (ip = CDRS(ber)[i]); ++i){
		for(j = 0; (jp = CDRS(ip)[j]); ++j){
			oid = localoid(CDRS(jp)[0]);
			if(oid == 12 || oid == 13){
				return(get_strs(CDRS(jp)[1]));
			}
		}
	}
	return("No email address");
}

getpubkey(ber, pub, parms)
BER			*ber;
struct RSAPublicKey	*pub;
struct RSAParameters	*parms;
{
	unsigned char		*p;
	BER			*b, *n, *e;
	struct RSAPublicKey	*key;
	int			i, j;

	p = CDRS(ber)[1]->val;
	while(!*p){
		++p;
	}
	b = deber(p);
	n = CDRS(b)[0];
	e = CDRS(b)[1];
	pub->n = (unsigned*)calloc(n->len, sizeof(unsigned));
	for(j = 0, i = n->len -1; i >= 1; i -= 2){
		pub->n[j++] = n->val[i] | (n->val[i-1] << 8);
	}
	for(i = e->len -1, pub->e = 0; i >= 0; --i){
		pub->e = (pub->e << 8) | e->val[i];
	}
	parms->len = j;
	parms->shift = 0;
}


prnname(ber)
BER	*ber;
{
	int	i, j;
	BER	*ip, *jp;

	for(i = 0; (ip = CDRS(ber)[i]); ++i){
		for(j = 0; (jp = CDRS(ip)[j]); ++j){
			printf("\t%s=%s\n",
				OIDstr[localoid(CDRS(jp)[0])],
				get_strs(CDRS(jp)[1]));
		}
	}
}


localoid(ber)
BER	*ber;
{
	int i;

	for(i = 1; *OID[i]; ++i){
		if(bcmp(ber->val, OID[i], ber->len) == 0){
			return(i);
		}
	}
	return(0);
}
	
cmpber(a, b)
BER	*a, *b;
{
	static unsigned char	ba[BUFSIZ], bb[BUFSIZ];
	int	ia, ib;

	ia = enber(a, ba);
	ib = enber(b, bb);
	if(ia - ib){
		return(ia -ib);
	}
	return(bcmp(ba, bb, ia));
}

cmp1ber(a, b)
BER	*a, *b;
{
	if((a->len == b->len) && (a->type == b->type)){
		return(bcmp(a->val, b->val, a->len));
	}
	return(1);
}

getint(ber)
BER	*ber;
{
	switch(ber->len){
	case 1:
		return(*(char *)(ber->val));
	case 2:
		/* return(*(short *)ber->val); */
		return(0x100 * *(unsigned char *)ber->val
			+ *((unsigned char *)ber->val + 1));
	case 3:
	case 4:
		/* return(*(int *)ber->val); */
		return(0x1000000 * *(unsigned char *)ber->val +
			 0x10000 * *((unsigned char *)ber->val +1)+
			   0x100 * *((unsigned char *)ber->val +2)+
			   	   *((unsigned char *)ber->val +3));

	}
	return(0);
}

char *get_strs(ber)
BER	*ber;
{
	char	*str;

	str = (char *)malloc(ber->len + 1);
	bcopy(ber->val, str, ber->len);
	str[ber->len] = '\0';
	return(str);
}



prnber(ber)
BER	*ber;
{
	int	i;

	printf("Type = %.2x (%d) ", ber->type, ber->len);
	for(i = 0; i < ber->len; ++i){
		printf("%.2x ", (char *)(ber->val)[i]);
	}
	printf("\n");
}

BER	*deber(bin)
unsigned char 	bin[];
{
	int	i, lenlen, seqlen;
	BER	*ber;
	unsigned char	*bptr;
	static unsigned char	kach = 0;

	ber = (BER *)malloc(sizeof(BER));
	ber->type = bin[0];
	if(bin[1] > 0x7f){
		lenlen  = bin[1] & 0x7f;
		ber->len = 0;
		for(i = 0; i < lenlen; ++i){
			ber->len = (ber->len << 8)+ bin[i + 2];
		}
	} else {
		ber->len = bin[1] & 0x7f;
		lenlen = 0;
	}
	ber->byte = 2 + lenlen + ber->len;
	bptr = &bin[2 + lenlen];
	if(ber->type == 0x30 || ber->type == 0x31){
		seqlen = ber->len;

		ber->val =(unsigned char*)calloc(SEQSIZE, sizeof(BER));
		for(i = 0; seqlen > 0; ++i ){
			((BER **)ber->val)[i] = deber(bptr);
			bptr   += ((BER **)ber->val)[i]->byte; 
			seqlen -= ((BER **)ber->val)[i]->byte; 
		}
		((BER **)ber->val)[i] = NULL; 
	} else if(ber->len == 0){
		ber->val = &kach;
	} else {
		ber->val = (unsigned char *)malloc(ber->len);
		if(ber->val == NULL){
			perror("BER decoding");
			exit(1);
		}
		bcopy(bptr, ber->val, ber->len); 
	}
	return(ber);
}

int	enber(ber, buf)
BER	*ber;
unsigned char	buf[];
{
	int	bufptr = 0;
	int	i;

	buf[bufptr++] = ber->type;
	if(ber->len < 0x80){
		buf[bufptr++] = ber->len;
	}else if(ber->len < 0x100){
		buf[bufptr++] = 0x81;
		buf[bufptr++] = ber->len;
	}else if(ber->len < 0x10000){
		buf[bufptr++] = 0x82;
		buf[bufptr++] = ber->len >> 8;
		buf[bufptr++] = ber->len & 0xff;
	}else{
		buf[bufptr++] = 0x84;
		*(long *)&buf[bufptr] = (long)ber->len;
		bufptr += 4;
	}
	if((ber->type == 0x30) || (ber->type == 0x31)){
		for(i = 0; ((BER **)ber->val)[i]; ++i){
			bufptr += enber(((BER **)ber->val)[i], &buf[bufptr]);
		}
	} else {
		bcopy(ber->val, &buf[bufptr], ber->len);
	}
	return(ber->byte);
}

int	enber2(ber, buf)
BER	*ber;
unsigned char	buf[];
{
	unsigned char	bin[BUFSIZ];
	int	bufptr = 0, binptr = 0;
	int	i;

	buf[bufptr++] = ber->type;
	if((ber->type == 0x30) || (ber->type == 0x31)){
		for(i = 0; ((BER **)ber->val)[i]; ++i){
			binptr += enber2(((BER **)ber->val)[i], &bin[binptr]);
		}
	} else {
		bcopy(ber->val, bin, ber->len);
		binptr = ber->len;
	}
	ber->len = binptr;
	if(binptr < 0x80){
		buf[bufptr++] = binptr;
	}else if(binptr < 0x100){
		buf[bufptr++] = 0x81;
		buf[bufptr++] = binptr;
	}else if(binptr < 0x10000){
		buf[bufptr++] = 0x82;
		buf[bufptr++] = binptr >> 8;
		buf[bufptr++] = binptr & 0xff;
	}else{
		buf[bufptr++] = 0x84;
		*(long *)&buf[bufptr] = (long)binptr;
		bufptr += 4;
	}
	bcopy(bin, &buf[bufptr], binptr);
	bufptr += binptr;
	ber->byte = bufptr;
	return(bufptr);
}


void	dispber(ber, tab)
BER	*ber;
char	*tab;
{
	int	i;
	char	tabstr[256];

	printf("%s%.2X (%d) ", tab, ber->type, ber->len);
	switch(ber->type){
	case 0x30:
	case 0x31:
		sprintf(tabstr, "%s    ", tab);
		for(i = 0; ((BER **)ber->val)[i]; ++i){
			dispber(((BER **)ber->val)[i], tabstr);
		}
		break;
	case 0x13:
	case 0x16:
	case 0x17:
		printf("[");
		for(i = 0; i < ber->len; ++i){
			putchar(ber->val[i]);
		}
		printf("]");
		break;
	default:
		for(i = 0; i < ber->len; ++i){
			printf("%.02x", ber->val[i]);
		}
	}
}



/*
main(argc, argv)
int	argc;
char	*argv[];
{
	unsigned char	buf[BSIZE];
	BER	*ber;
	int	i, c;

	fread(buf, 1, BSIZE, stdin);
	ber = deber(buf);

	while((c = getopt(argc, argv, "ed")) != -1){
		switch(c){
		case 'e':
			i = enber(ber, buf);
			fwrite(buf, 1, i, stdout);
			break;

		case 'd':
			dispber(ber, "\n");
			printf("\n\n");
			break;

		default:
			fprintf(stderr, "usage: ber [-e|-d]\n ");
		}
	}
}
*/
