/* keylib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: keylib.c,v 1.1 1995/03/08 06:04:36 kuroda Exp $ */
/*
***	keylib.c -	get keys from Key-Info,	Aug. 30, 93/kikn
 */

#include	<stdio.h>
#include	"pem.h"
#include	"cert.h"
#include	"rsa.h"



getkey(args, dek, mykey, parms)
char		args[];
unsigned char	dek[];
struct	RSASecretKey	*mykey;
struct	RSAParameters	*parms;
{
	unsigned	*cert;
	static unsigned	buf[BUFSIZ];
	unsigned char	bin[BUFSIZ];
	int		i, c;

	sscanf(args, "%[^,]", buf);
	if(strcmp(buf, "RSA")){
		fprintf(stderr, "unacceptable encryption %s\n", buf);
		return(1);
	}
	bzero(bin, sizeof bin);
	c = freadfield(fin, bin);

	char2word(bin, buf, c); 
	rsa_decrypt(buf, &cert, mykey, parms);
	word2char(cert, bin, parms->len);

	padout(bin, dek, 8); 
	if(verbose){
		fhexdump(stderr, cert, parms->len -1);
		fprintf(stderr, "\nDEK = %.4x%.4x\n", *(int *)&dek[0], *(int *)&dek[4]);
	}

	return(0);
}

keyinfo(dek, pub, parms)
unsigned char	dek[];
struct RSAPublicKey	*pub;
struct RSAParameters	*parms;
{
	static	unsigned char	bin[BUFSIZ];
	static	unsigned 	buf[BUFSIZ], *w;
	int	bytes;

	bytes = parms->len * 2;
	pad(2, dek, DEKSIZE, bin, bytes);

	char2word(bin, buf, bytes); 
	rsa_encrypt(buf, &w, pub, parms);
	word2char(w, bin, parms->len);

	fputs("Key-Info: RSA,\n", fout);
	writebyte(bin, bytes);
	writebyte(bin, 0);
}

		

