/* Copyright (C) 1992 Eric Young - see COPYING for more details */
/* $Id: libcfb.c,v 1.1 1995/11/13 07:52:45 kuroda Exp $ */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../DES/des.h"

#ifdef SOLARIS
#include "solaris.h"
#endif

#define BUFSIZE (8*1024)
#define KEYSIZ	8
#define KEYSIZB 1024 /* should hit tty line limit first :-) */

extern	void	initcfb();
extern	int	encfb();
extern	int	decfb();

static des_key_schedule 	ks;
static char 	key[KEYSIZB+1];
static char 	rbuf[BUFSIZE+8];
static char 	cbuf[BUFSIZE+8];
static int	fbsize = 8;

static int 	encrypt;
static int 	kflag, error;


void initcfb(key)
char* key;
{
	static des_cblock kk;

	des_string_to_key(key,kk);
	des_set_key(kk,ks);
	bzero(key,sizeof(key));
	bzero(kk,sizeof(kk));
	bzero(rbuf,sizeof(rbuf));
	bzero(cbuf,sizeof(cbuf));
	/* deleted by Fujitsu Laboratories Ltd.
	srand(time(NULL));
	for(i = 0; i < idletime; ++i){
		rbuf[i] = rand() & 0xff;
	}
	fwrite(rbuf,1,idletime,DES_OUT);
	end */
}

/* deleted by Fujitsu Laboratories Ltd.
int encfb(c)
int c;
{
	des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
	bcopy(rbuf, rbuf+1, fbsize -1);
	rbuf[0] = c^cbuf[0];	
	return(rbuf[0]);
}

int decfb(c)
int c;
{
	des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
	bcopy(rbuf, rbuf+1, fbsize -1);
	rbuf[0] = c;
	return(c^cbuf[0]);	
}
end */

/* added by Fujitsu Laboratories Ltd. */

int encfb(c)
int c;
{
	static int	i = 8;

	if(i == 8){
		des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
		i = 0;
	}
	rbuf[i] = c^cbuf[i];
	return(rbuf[i++]);
}

int decfb(c)
int c;
{
	static int	i = 8;

	if(i == 8){
		des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
		i = 0;
	}
	rbuf[i] = c;
	return(c^cbuf[i++]);	
}

/* end */
