/*$Id: libcfb2.c,v 1.1 1995/11/13 07:52:47 kuroda Exp $ */
/* Copyright (C) 1992 Eric Young - see COPYING for more details */
/* modify by kuroda@flab.fujitsu.co.jp from libcfb.c */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../DES/des.h"

#define BUFSIZE (8*1024)
#define KEYSIZ	8
#define KEYSIZB 1024 /* should hit tty line limit first :-) */

#ifdef SOLARIS
#include "solaris.h"
#endif

extern	void	initcfb2();
extern	int	encfb2();
extern	int	decfb2();

static des_key_schedule 	ks;
static char 	key[KEYSIZB+1];
static char 	rbuf[BUFSIZE+8];
static char 	cbuf[BUFSIZE+8];
static int	fbsize = 8;

static int 	encrypt;
static int 	kflag, error;


void initcfb2(key)
char* key;
{
	static des_cblock kk;

	des_string_to_key(key,kk);
	des_set_key(kk,ks);
	bzero(key,sizeof(key));
	bzero(kk,sizeof(kk));
	bzero(rbuf,sizeof(rbuf));
	bzero(cbuf,sizeof(cbuf));
	/*
	srand(time(NULL));
	for(i = 0; i < idletime; ++i){
		rbuf[i] = rand() & 0xff;
	}
	fwrite(rbuf,1,idletime,DES_OUT);
	*/
}

/*
int encfb2(c)
int c;
{
	des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
	bcopy(rbuf, rbuf+1, fbsize -1);
	rbuf[0] = c^cbuf[0];	
	return(rbuf[0]);
}

int decfb2(c)
int c;
{
	des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
	bcopy(rbuf, rbuf+1, fbsize -1);
	rbuf[0] = c;
	return(c^cbuf[0]);	
}
*/

int encfb2(c)
int c;
{
	static int	i = 8;

	if(i == 8){
		des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
		i = 0;
	}
	rbuf[i] = c^cbuf[i];
	return(rbuf[i++]);
}

int decfb2(c)
int c;
{
	static int	i = 8;

	if(i == 8){
		des_ecb_encrypt(rbuf, cbuf, ks, DES_ENCRYPT);
		i = 0;
	}
	rbuf[i] = c;
	return(c^cbuf[i++]);	
}
