#define LINEBUFSIZE  	120
#define PUBKEYSIZE    256
#ifndef KEYSIZE		/* this value is also defined in cert.h */
#define KEYSIZE      32
#endif
#define MAX_PRENCODE_BYTES 48
#define MAXRECIP     32

#define	CERTSIZE	((KEYSIZE-1)*3)
#define	DNSIZE		(32)
#define ISSUER		0
#define SUBJECT		DNSIZE
#define PUBLICKEY	(DNSIZE*2)
#define	COLSIZE		64
#define	COLBUF		(COLSIZE+2)
#define COLBYTE         48
#define LINESIZE        ((KEYSIZE+1)*2)
#define DEKSIZE		8
#define CBCSIZE         (8*1024)

#define	MDSIZE		34
#define MICSIZE		16

#define SWAP(a,b)       {FILE* c; c=a; a=b; b=c;}
#define swap(a,b)       b^=a,a^=b,b^=a

#ifndef MASK            /* this value is also defined in RSA/numalgs.h */
#define MASK 0xffff
#endif

/* typedefs */
typedef struct{
	unsigned char   type;
	int             len;
	int             byte;
	unsigned char   *val;
} BER;

/* common */
extern  int     verbose;
/*extern  int     integrity;
extern  int     encrypttype;*/
extern FILE	*fin, *fout;
extern char	*mycert, *issuercert, *mymail;
extern	int	prntype;	

/* in berlib.c */
extern	int		enber();
extern	void		dispber();
extern	BER		*deber();
extern	char		*get_strs();
extern	char		*OIDstr[];
extern	unsigned char	OID[][16];
extern	char		*getmail();

/* cerlib.c */
extern	char		*vfysig();
extern	BER		*readpubkey();
extern	BER		*readcert();

/* miclib.c */
extern	BER		*micinfo();

/* dpmlib.c */
extern	BER		*getber();

/* siglib.c */
extern	char		*sign();

#ifdef SOLARIS
#include <string.h>
#define bcopy(b1,b2,l) 	memmove(b2,b1, (size_t)(l))
#define bzero(b,l) 	memset(b, 0, (size_t)(l))
#define bcmp(b1,b2,l) 	memcmp(b1,b2, (size_t)(l))
#define srandom(s)	srand48((long)s)
#define random()	lrand48()
#endif
