/*
ALL Rights Reserved, Copyright(c)FUJITSU LABORATORIES LTD. 1995
Privacy Enhanced Telnet

			 PERMISSION NOTICE
			 -----------------
			Wed, Dec 27th, 1995

		    FUJITSU LABORATORIES LTD.
  1015 Kamikodanaka, Nakahara-ku, Kawasaki-shi, Kanagawa-ken 211, Japan

Permission to use, copy, modify and distribute this Software (including its
relevand documentation) is hereby granted without fee under the
following terms and conditions:

1. Both of copyright notices in this Software and this permission
notice shall be duplicated in copies and modification of all or a part 
of this Software.

2. This Software may be used for the profit-making purposes, provided
that sale of this Software, whether incorporated in other products as
a part thereof or not, is prohibited and that the name FUJITSU
LABORATORIES LTD. may not be used externally in relation with the use
for such profit-making purposes without specific prior written
permission.

3. On publication or presentation in any form, of the results obtained 
by use of this Software, an explicit reference to this Software and
its copyright owner shall be made.

4. THIS SOFTWARE IS PROVIDED ``AS IS" AND FUJITSU LABORATORIES
LTD. MAKES NO WARRANTIES, EITHER EXPRESSED OR IMPLIED, AS TO ANY
MATTER WHATSOEVER REGARDING TO THIS SOFTWARE, INCLUDING, WITHOUT
LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
PARTICULAR PUPRPOSE.
IN NO EVENT SHALL FUJITSU LABORATORIES LTD. BE LIABLE FOR ANY CLAIM
FROM A THIRD PARTY, OR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
ARISING OUT OF OR IN CONNECTION WITH THE USE, COPYING, MODIFICATION OR 
DISTRIBUTION OF THIS SOFTWARE.

5. this Software includes the following free software, and such free
software shall be used in accordance with the permission notices
attached to each such free software:


MANE OF FREE SOFTWARE	NAME OF DIRECTORY	NAME OF COPYRIGHT OWNER
UCB Telnet              telnet			UCB (1)        
UCB Telnetd             telnetd			UCB            
UCB libtelnet           libtelnet		UCB            
GNU DES Libray          DES			Eric Young     
OSISEC RSA Libray       RSA			Peter Williams 
OSISEC MD Libray        MD			Peter Williams 
transit		        transit			ASCII Corporation
bplus               	bplus			K.Suzuki(katsu@wide.ad.jp)
						T.Taniguchi(tani@wide.ad.jp)
zmodem              	zmodem			Omen Technology Inc.
telnetx                 telnet/telnetx.c	UEC (2)      

PET3 Library            pet			FUJITSU LABORATORIES LTD.

	(1) UCB: The University of California, Berkeley School
	(2) UEC: The University of Electro-Communications


*/


#define LINEBUFSIZE  	120
#define PUBKEYSIZE    256
#ifndef KEYSIZE		/* this value is also defined in cert.h */
#define KEYSIZE      32
#endif
#define MAX_PRENCODE_BYTES 48
#define MAXRECIP     32

#define	CERTSIZE	((KEYSIZE-1)*3)
#define	DNSIZE		(32)
#define ISSUER		0
#define SUBJECT		DNSIZE
#define PUBLICKEY	(DNSIZE*2)
#define	COLSIZE		64
#define	COLBUF		(COLSIZE+2)
#define COLBYTE         48
#define LINESIZE        ((KEYSIZE+1)*2)
#define DEKSIZE		8
#define CBCSIZE         (8*1024)

#define	MDSIZE		34
#define MICSIZE		16

#define SWAP(a,b)       {FILE* c; c=a; a=b; b=c;}
#define swap(a,b)       b^=a,a^=b,b^=a

#ifndef MASK            /* this value is also defined in RSA/numalgs.h */
#define MASK 0xffff
#endif

/* typedefs */
typedef struct{
	unsigned char   type;
	int             len;
	int             byte;
	unsigned char   *val;
} BER;

/* common */
extern  int     verbose;
/*extern  int     integrity;
extern  int     encrypttype;*/
extern FILE	*fin, *fout;
extern char	*mycert, *issuercert, *mymail;
extern	int	prntype;	

/* in berlib.c */
extern	int		enber();
extern	void		dispber();
extern	BER		*deber();
extern	char		*get_strs();
extern	char		*OIDstr[];
extern	unsigned char	OID[][16];
extern	char		*getmail();

/* cerlib.c */
extern	char		*vfysig();
extern	BER		*readpubkey();
extern	BER		*readcert();

/* miclib.c */
extern	BER		*micinfo();

/* dpmlib.c */
extern	BER		*getber();

/* siglib.c */
extern	char		*sign();

#ifdef SOLARIS
#include <string.h>
#define bcopy(b1,b2,l) 	memmove(b2,b1, (size_t)(l))
#define bzero(b,l) 	memset(b, 0, (size_t)(l))
#define bcmp(b1,b2,l) 	memcmp(b1,b2, (size_t)(l))
#define srandom(s)	srand48((long)s)
#define random()	lrand48()
#endif
