/* $Id: pet_server.c,v 1.9 1996/02/07 01:21:04 kuroda Exp $ */
/*
ALL Rights Reserved, Copyright(c)FUJITSU LABORATORIES LTD. 1995
Privacy Enhanced Telnet

			 PERMISSION NOTICE
			 -----------------
			Wed, Dec 27th, 1995

		    FUJITSU LABORATORIES LTD.
  1015 Kamikodanaka, Nakahara-ku, Kawasaki-shi, Kanagawa-ken 211, Japan

Permission to use, copy, modify and distribute this Software (including its
relevand documentation) is hereby granted without fee under the
following terms and conditions:

1. Both of copyright notices in this Software and this permission
notice shall be duplicated in copies and modification of all or a part 
of this Software.

2. This Software may be used for the profit-making purposes, provided
that sale of this Software, whether incorporated in other products as
a part thereof or not, is prohibited and that the name FUJITSU
LABORATORIES LTD. may not be used externally in relation with the use
for such profit-making purposes without specific prior written
permission.

3. On publication or presentation in any form, of the results obtained 
by use of this Software, an explicit reference to this Software and
its copyright owner shall be made.

4. THIS SOFTWARE IS PROVIDED ``AS IS" AND FUJITSU LABORATORIES
LTD. MAKES NO WARRANTIES, EITHER EXPRESSED OR IMPLIED, AS TO ANY
MATTER WHATSOEVER REGARDING TO THIS SOFTWARE, INCLUDING, WITHOUT
LIMITATION, WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
PARTICULAR PUPRPOSE.
IN NO EVENT SHALL FUJITSU LABORATORIES LTD. BE LIABLE FOR ANY CLAIM
FROM A THIRD PARTY, OR SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
ARISING OUT OF OR IN CONNECTION WITH THE USE, COPYING, MODIFICATION OR 
DISTRIBUTION OF THIS SOFTWARE.

5. this Software includes the following free software, and such free
software shall be used in accordance with the permission notices
attached to each such free software:


MANE OF FREE SOFTWARE	NAME OF DIRECTORY	NAME OF COPYRIGHT OWNER
UCB Telnet              telnet			UCB (1)        
UCB Telnetd             telnetd			UCB            
UCB libtelnet           libtelnet		UCB            
GNU DES Libray          DES			Eric Young     
OSISEC RSA Libray       RSA			Peter Williams 
OSISEC MD Libray        MD			Peter Williams 
transit		        transit			ASCII Corporation
bplus               	bplus			K.Suzuki(katsu@wide.ad.jp)
						T.Taniguchi(tani@wide.ad.jp)
zmodem              	zmodem			Omen Technology Inc.
telnetx                 telnet/telnetx.c	UEC (2)      

PET3 Library            pet			FUJITSU LABORATORIES LTD.

	(1) UCB: The University of California, Berkeley School
	(2) UEC: The University of Electro-Communications



*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>

#include "../telnetd/defs.h"
#include "../telnetd/ext.h"

#include "../DES/des.h"
#include "../RSA/numalgs.h"
#include "../RSA/rsa.h"

#include "pet.h"
#include "pet2.h"
#include "cert.h"

FILE *fin, *fout;
int verbose = 0;

char *seclevel_table[] = {
    "110000",
    "112040",
    "022040",
    "002305",
    "000040",
    "000045"
};

#define KEYSIZB 1024

extern  void    initcfb();
extern  void    initcfb2();

extern  void    initcfb3();
extern  int     encfb3();
extern  int     decfb3();

des_key_schedule kss;
des_key_schedule ks;
int fbsize = 8;
static char     key3[KEYSIZB+1];
static char     rrbuf[BUFSIZ];
static char     ccbuf[BUFSIZ];
static char     rbuf[BUFSIZ];
static char     cbuf[BUFSIZ];
static char     key[KEYSIZB+1];

unsigned char dek1[1024], dek11[1024], dek22[1024], dek2[1024], encdek2[1024];

static int      binptr2 = 0, nbytes2 = 0;

BER *getber3();
BER *getber2();
BER *getber();
BER *client;
char sseed[1024];
struct  RSAPublicKey    cpub;
struct  RSAParameters   cparms;

pet_server_signature(cseed)
char *cseed;
{
    FILE *fp;
    BER *server;
    struct  RSASecretKey     *skey = NULL;
    struct  RSAPublicKey    spub;
    struct  RSAParameters   sparams, s_params;

    char padstr[1024];
    unsigned char seed[1024];
    static unsigned char bin[1024];
    static unsigned buf[1024];
    static  unsigned  *w;
    char *scertfile = SERVER_CERT_FILE;
    char *skeyfile = SERVER_KEY_FILE;


    /* initial custamize */
    if((fp = fopen(scertfile, "r")) == NULL){
        fprintf(stderr, "Bad \"%s\" file\n", scertfile);
        exit(1);
    }
    server = getber3(fp);
    fclose(fp);
    getpubkey(C_PK(server), &spub, &sparams);
    rsa_read_secret_key(skeyfile, &skey, &s_params);

    str2char(cseed, seed);
    pad(1, seed, 8, bin, (sparams.len*2));
    char2word(bin, buf, (sparams.len*2));
    rsa_decrypt(buf, &w, skey, sparams);
    word2char(w, bin, sparams.len);
    char2str(bin, padstr, (sparams.len *2));
    pet_write_data(SSIG, padstr);

}


pet_server_send_cert(){
    FILE *fp;
    char c; int i;
    static unsigned char        buff[BUFSIZ];
    char *scertfile = SERVER_CERT_FILE;

   if((fp = fopen(scertfile, "r")) == NULL){
        fprintf(stderr, "Bad \"%s\" file\n", scertfile);
        exit(1);
    }
    for(i=0; (c = fgetc(fp)) != EOF; i++){
        buff[i] = c;
    }
    fclose(fp);

/*    buff[i] = '\0';*/

    pet_write_data(SCERT, buff);

}


pet_server_vfy_sigseed(sigseed)
char *sigseed;
{
    FILE *fp;
/*    struct  RSAPublicKey    cpub;
    struct  RSAParameters   cparams;*/
    char *errstr, sseed2[1024];
    unsigned char seed2[1024];
    static unsigned char bin[1024], bin2[1024];
    static unsigned buf[1024];
    static  unsigned  *w, *ww;
    char *valid = "valid\0", *invalid = "invalid\0";

/*    getpubkey(C_PK(client), &cpub, &cparms);*/

    str2char(sigseed, bin);
    char2word(bin, buf, (cparms.len*2));
    rsa_encrypt(buf, &ww, cpub, cparms);
    word2char(ww, bin2, cparms.len);
    padout(bin2, seed2, 8);
    char2str(seed2, sseed2, 8);

   if(!strcmp(sseed, sseed2)){
        pet_write_data(SSEEDRESULT, valid);
    }else{
        pet_write_data(SSEEDRESULT, invalid);
    }
/*    fp = fopen("/tmp/telnet3d", "a");
    fprintf(fp, "seed1 = %s\n", sseed);
    fprintf(fp, "seed2 = %s\n", sseed2);
    fclose(fp);*/

}


pet_server_send_seed(){
    unsigned char seed[1024];
    FILE *fp;

    srandom((int)time(NULL) + getpid());
    makedek(seed);
    char2str(seed, sseed, 8);

    pet_write_data(SSEED, sseed);
/*    fp = fopen("/tmp/telnet3d", "a");
    fprintf(fp, "seed1(f) = %s\n", sseed);
    fclose(fp);*/

}

pet_server_rcv_ccert(ccert)
char *ccert;
{
    FILE *fp;
    BER *myissuer;
    struct  RSAPublicKey    ipub;
    struct  RSAParameters   iparms;
    static unsigned char        buff[BUFSIZ];
    char *errstr;
    char *sissuerfile = SERVER_ISSUER_FILE;
    char *valid = "valid", *invalid = "invalid";
    int cserial, dbserial, serialflag = 0;
    char *pet_user = SERVER_USER_MANAGEMENT_FILE;

    /* read issuer certificate */
    if((fp = fopen(sissuerfile, "r")) == NULL){
        fprintf(stderr, "Bad \"%s\" file\n", sissuerfile);
        exit(1);
    }
    myissuer = getber3(fp);
    fclose(fp);
    getpubkey(C_PK(myissuer), &ipub, &iparms);

/*    fp = fopen("/tmp/telnet3d", "a");*/
    client = getber2(ccert);
    cserial = SerialNumber(client);
/*    fprintf(stderr, "serial = %X\n", cserial);*/

    if((fp = fopen(pet_user, "r")) == NULL){
	fprintf(stderr, "Can't open file\m");
    }

    while(fscanf(fp, "%X", &dbserial) == 1){
	if(dbserial == cserial){
	    serialflag = 1;
	    break;
	}
    }

    getpubkey(C_PK(client), &cpub, &cparms);
    errstr = vfysig(client, &ipub, &iparms);
   if(errstr || serialflag == 0){
/*       fprintf(fp, "certvfy = invalid\n");*/
       pet_write_data(CCERTRESULT, invalid);
    }else{
/*       fprintf(fp, "certvfy = valid\n");*/
       pet_write_data(CCERTRESULT, valid);
    }
/*    fclose(fp);*/
}

pet_server_get_dek1(keyinfo)
char *keyinfo;
{
    struct RSASecretKey *key = NULL;
    struct RSAParameters *parms;
    static  unsigned char   bin[BUFSIZ];
    char *seckeyfile = SERVER_KEY_FILE, writedata[BUFSIZ];
    int i;
    FILE *fp;

    rsa_read_secret_key(seckeyfile, &key, &parms);
    str2char(keyinfo, bin);
    getdek(bin, dek1, key, parms);

    char2str(dek1, dek11, DEKSIZE);
/*    fp = fopen("/tmp/telnet3d", "a");
    fprintf(fp, "dek1 = %s\n", dek11);*/

    initcfb3(dek11);

    srandom((int)time(NULL) + getpid());
    makedek(dek2);
    for(i=0; i<DEKSIZE; i++){
        encdek2[i] = encfb3(dek2[i]);
    }
    char2str(encdek2, writedata, DEKSIZE);
    writedata[DEKSIZE*2] = '\0';

    pet_write_data(DEK2, writedata);

    char2str(dek2, dek22, DEKSIZE);

/*    fprintf(stderr, "dek22(s) = %s\n", dek22);*/
    initcfb(dek22);
    initcfb2(dek22);

/*    fclose(fp);*/
/*    pet_mode = 1;*/

}


pet_server_process(){

    pet_server_req_level();

}

pet_server_rcv_level(rlevel)
char *rlevel;
{
    FILE *fp;

    sreal_level = seclevel_table[atoi(rlevel)][atoi(sreq_level)];

    switch(sreal_level){

    case '0':
	fprintf(stderr, "Security level negotiation is fault.\n");
	exit(0);
	break;

    case '1':
	pet_mode = 0;
	pet_process = 0;
	return;
	break;

    case '2':
    case '3':
    case '4':
    case '5':
	pet_server_send_pubkey();
	break;

    }    
/*    pet_server_send_pubkey();*/


}

pet_server_send_pubkey(){
    struct RSASecretKey *key = NULL;
    struct RSAParameters *parms;
    char *seckeyfile = SERVER_KEY_FILE;
    char pubkey[1024];
    FILE *fp;

    rsa_read_secret_key(seckeyfile, &key, &parms);
    hexdump2(key->n, pubkey, KEYSIZE - 1);
/*    fp = fopen("/tmp/telnet3d", "a");
    fprintf(fp, "pubkey = %s\n", pubkey);
    fclose(fp);*/
    pet_write_data(SPUBKEY, pubkey);
}

pet_server_req_level(){

    if(strcmp(sreq_level, "") == 0){
        sreq_level[0] = '5';
	sreq_level[1] = '\0';
    }

    pet_write_data(SREQLEVEL, sreq_level);

}
    
pet_write_data(type, data)
char type;
char *data;
{
    char send_data[1024];
    int i, j, len;
    FILE *fp;
    
    send_data[0] = IAC;
    send_data[1] = PET;
    send_data[2] = type;

    len = strlen(data);
    for(i=3, j=0; j<len+1; i++,j++)
        send_data[i] = data[j];

    len = strlen(send_data);

    write(net, send_data, len+1);

}

hexdump2(indata, outdata, l)
unsigned indata[];
char outdata[];
int             l;
{
    int             i, j, len;
    unsigned        n;
    char tmp[10];
    FILE *fp;

    for (i = l; i >= LSW; i--) {
        n = indata[i];
        for (j = 0; j < BITS; j = j + 4) {
            sprintf(tmp, "%x", n >> HNIB);
            strcat(outdata,tmp);
            n = (n << 4) & MASK;
        }
    }

}


padout(in, out, size)
unsigned char   *in, *out;
int             size;
{
    ++in; /* for the precedig 00 */
    while(*in++) ;
    while(size-- > 0){
        *out++ = *in++;
    }
}


hexin2(in, a, l)
char in[];
unsigned a[];
int l;
{
    int             i;
    int             j;
    int k;
    int             n;
    char            c;

    k=0;
    for (i = l; i >= 0; i--) {
        a[i] = 0;
        for (j = 0; j < NPW; j++) {
            /*                        c = getc(f);*/
            c = in[k++];
            n = (int) c - (int) '0';
            if (c > '9')
                n = (int) c - (int) 'a' + 10;
            a[i] = (a[i] << 4) + n;
        }
    }
}

keyinfo(dek, pub, parms, bin)
unsigned char   dek[];
struct RSAPublicKey     *pub;
struct RSAParameters    *parms;
unsigned char  bin[];
{
    static  unsigned        buf[BUFSIZ], *w;
    int     bytes, i;

    bytes = parms->len * 2;
    pad(2, dek, DEKSIZE, bin, bytes);

    char2word(bin, buf, bytes); 
    rsa_encrypt(buf, &w, pub, parms);
    word2char(w, bin, parms->len);

}


getdek(bin, dek, mykey, parms)
unsigned char  bin[];
unsigned char   dek[];
struct  RSASecretKey    *mykey;
struct  RSAParameters   *parms;
{
    unsigned        *cert;
    static unsigned buf[BUFSIZ];
    int             i, c;

    char2word(bin, buf, (parms->len *2)); 
    rsa_decrypt(buf, &cert, mykey, parms);
    word2char(cert, bin, parms->len);

    padout(bin, dek, 8); 

    return(0);

}

makedek(dek)
unsigned char   dek[];
{
    int     i, j, s;

    for(i = 0; i < DEKSIZE; ++i){
        dek[i] = random() & 0x7f;
        for(j = 0, s = 0; j < 7; ++j){
            s += (dek[i] >> j) & 1;
        }
        if(s & 1){
            dek[i] |= 0x80;
        }
    }
}

char2str(inbuf, outbuf, len)
unsigned char inbuf[];
char outbuf[];
int len;
{
    int i;
    char tmp[10];
    FILE *fp;

    outbuf[0] = '\0';
    for(i=0; i<len; i++){
        sprintf(tmp, "%02x", inbuf[i]);
        strcat(outbuf, tmp);
    }

}

str2char(inbuf, outbuf)
char inbuf[];
unsigned char outbuf[];
{
    int i, j, n, nn, len;

    len = strlen(inbuf);
    for(i=0,j=0; i<len; ++i){
        n = (int)inbuf[i] - (int)'0';
        if(inbuf[i] > '9')
            n = (int)inbuf[i] - (int)'a' +10;
        n = n*16; ++i;
        nn = (int)inbuf[i] - (int)'0';
        if(inbuf[i] > '9')
            nn = (int)inbuf[i] - (int)'a' +10;
        n = n + nn;
        outbuf[j++] = n;
    }

}



char2word(c, w, csize)
unsigned char   c[];
unsigned int    w[];
int             csize;
{
    int     i, j;

    for(i = csize -1, j = 0; i >= 0; i -= 2){
        w[j++] = c[i] + (c[i-1] << 8);
    }
}

word2char(w, c, wsize)
unsigned int    w[];
unsigned char   c[];
int             wsize;
{
    int     i, j;

    for(i = wsize -1, j = 0; i >= 0; --i){
        c[j++] = w[i] >> 8;
        c[j++] = w[i] & 0xff;
    }
}

/*  padding according to PKCS #1 */

pad(type, dek, msize, pad, psize)
unsigned char   *dek, *pad, type;
int             msize, psize;
{
    int     i, mp;
    mp = psize - msize -1;

    pad[0] = 0;
    pad[1] = type;
    for(i = 2; i < mp; ++i){
        do{
            pad[i] = (type == 1)? 0xff: (random()) & 0xff;
        }while(pad[i] == 0);
    }
    pad[mp] = 0;
    bcopy(dek, &pad[mp +1], msize);
}

void initcfb3(key3)
char* key3;
{
        static des_cblock kkk;

        des_string_to_key(key3,kkk);
        des_set_key(kkk,kss);
        bzero(key3,sizeof(key3));
        bzero(kkk,sizeof(kkk));
        bzero(rrbuf,sizeof(rrbuf));
        bzero(ccbuf,sizeof(ccbuf));

}

int encfb3(c)
int c;
{
        static int      i = 8;

        if(i == 8){
                des_ecb_encrypt(rrbuf, ccbuf, kss, DES_ENCRYPT);
                i = 0;
        }
        rrbuf[i] = c^ccbuf[i];
        return(rrbuf[i++]);
}

int decfb3(c)
int c;
{
        static int      i = 8;

        if(i == 8){
                des_ecb_encrypt(rrbuf, ccbuf, kss, DES_ENCRYPT);
                i = 0;
        }

        rrbuf[i] = c;
        return(c^ccbuf[i++]);    
}

BER*
getber2(buff)
unsigned char   buff[];
{
    unsigned char   buf[BUFSIZ];

    bufreadfield(buff, buf);
    return(deber(buf));
}

BER*
getber3(fp)
FILE *fp;
{
    unsigned char   buf[BUFSIZ];

    bufreadfield2(fp, buf);
    return(deber(buf));
}

bufreadfield(buff, field)
unsigned char   buff[];
unsigned char   field[];
{
/*    static unsigned char        buff[BUFSIZ];*/
    static unsigned char        bin[BUFSIZ];
    static unsigned char        line[BUFSIZ];
    int   len, i, j;
    int binptr = 0, nbytes = 0;
    char        *cp, *tp;
    int c;

/*    for(i=0; (c = fgetc(f)) != EOF; i++){
        buff[i] = c;
    }*/

    len = strlen(buff);
/*    fprintf(stderr, "len = %d\n", len);*/
/*    while((cp = fgets(line, BUFSIZ, f)) != NULL && line[0] == ' '){*/
    for(i=0; i<len; i++){
        j=0;
        while(buff[i] != '\n'){
            line[j++] = buff[i++];
/*          fprintf(stderr, "%c", line[j]);*/
        }
        c = strlen(line);
        /* if(verbose) printf("[%d]%s", c, line); */
/*      printf("[%d]%s", c, line); */
        nbytes += prdecode(line, &field[nbytes], (c-1)*6/8);
        if(tp = strpbrk(line, "=,")){
            if(verbose){
                fprintf(stderr, "\tNo ungetc,(%d) \n", nbytes);
            }
            if(tp = strpbrk(tp, ",")){
                if(verbose) fprintf(stderr, "ungets(%s)\n", tp + 1);
                ungets(tp + 1);
            }
            return(nbytes);
        }
    }
    if(cp != NULL){
        ungets(line);
    }
    if(verbose) fprintf(stderr, "(%d)\n", nbytes);
    return(nbytes);
}


bufreadfield2(f, field)
FILE *f;
unsigned char   field[];
{
    static unsigned char        buff[BUFSIZ];
    static unsigned char        bin[BUFSIZ];
    static unsigned char        line[BUFSIZ];
    int   len, i, j;
    int binptr = 0, nbytes = 0;
    char        *cp, *tp;
    int c;

/*    fprintf(stderr, "%s\n", buff);*/
    for(i=0; (c = fgetc(f)) != EOF; i++){
        buff[i] = c;
    }

    len = strlen(buff);
/*    fprintf(stderr, "len = %d\n", len);*/
/*    while((cp = fgets(line, BUFSIZ, f)) != NULL && line[0] == ' '){*/
    for(i=0; i<len; i++){
        j=0;
        while(buff[i] != '\n'){
            line[j++] = buff[i++];
/*          fprintf(stderr, "%c", line[j]);*/
        }
        c = strlen(line);
        /* if(verbose) printf("[%d]%s", c, line); */
/*      printf("[%d]%s", c, line); */
        nbytes += prdecode(line, &field[nbytes], (c-1)*6/8);
        if(tp = strpbrk(line, "=,")){
            if(verbose){
                fprintf(stderr, "\tNo ungetc,(%d) \n", nbytes);
            }
            if(tp = strpbrk(tp, ",")){
                if(verbose) fprintf(stderr, "ungets(%s)\n", tp + 1);
                ungets(tp + 1);
            }
            return(nbytes);
        }
    }
    if(cp != NULL){
        ungets(line);
    }
    if(verbose) fprintf(stderr, "(%d)\n", nbytes);
    return(nbytes);


}
