/* alg_rsa.h - Access Header for OSISEC-conformant implementation of RSA */

#ifndef _OSISEC_RSA_DEFINED_
#define _OSISEC_RSA_DEFINED_

#define	OK	0
#define NOTOK	(!OK)

/* from keysize.h */
#define HALFKEYSIZE 16
#define KEYSIZE 32
#define KEYCHARS 64

typedef void *RSAEncrypted;
#define NULLENCRYPTED ((unsigned*)0)

struct RSASecretKey {
	unsigned       *p;
	unsigned       *q;
	unsigned       *a;
	unsigned       *n;
	unsigned       *d;
	unsigned       *d1;
	unsigned       *d2;
};

struct RSAPublicKey {
	unsigned       *n;
	unsigned        e;
};

struct RSAParameters {
	int             len;
	int             shift;
};

#endif
#ifdef _HAVE_NO_CFREE_
#define cfree(x)	free(x)
#endif

#ifdef SOLARIS
#include <string.h>
#define bcopy(b1,b2,l)	memmove(b2,b1, (size_t)(l))
#define bzero(b,l)	memset(b, 0, (size_t)(l))
#define bcmp(b1,b2,l)	memcmp(b1,b2, (size_t)(l))
#define srandom(s)	srand48((long)s)
#define random()	lrand48()
#endif

