/* testber.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: testber.c,v 1.1 1995/03/08 06:04:43 kuroda Exp $ */
/*
***	testber.c - test for BER decoding	Aug. 6, 93/kikn
 */

#include	<stdio.h>
#include	"pem.h"
#include	"cert.h"
#include	"rsa.h"


char	usage[]	= "usage: %s [-cdpf] < user.cert\n\twhere \t-c means certificate information\n\t\t-d means display\n\t\t-p means publick key extract\n";


FILE    *fin = stdin;
FILE    *fout = stdout;
int     verbose = 0;
int     integrity = 0;
int     encrypttype = 1;
char    *mycert = NULL;
char    *issuercert = NULL;

main(argc, argv)
int argc;
char *argv[];
{
	unsigned char	buf[BUFSIZ];
	int	c, i;
	BER	*ber;
	extern char	*optarg;
	struct RSAPublicKey	pub;
	struct RSAParameters	parms;

	while((c = getopt(argc, argv, "cdpfhs")) != -1){
		switch(c){
		case 'f':
			c = freadfield(stdin, buf);
			printf("NUM = %d\n", c);
			for(i = 0; i < c; ++i){
				printf("%.2x", buf[i]);
			}
			printf("\n");
			gets(buf);
			printf("Next is \"%s\"\n", buf);
			break;

		case 'p':
			freadbyte(stdin, buf, BUFSIZ);
			ber = deber(buf);
			/* dispber(C_PK(ber),"\n"); */
			getpubkey(C_PK(ber), &pub, &parms);
			/* printf( "len = %d\n", parms.len ); */
			printf( "L = %d\n", parms.len * 16 -parms.shift);
			printf( "N  = " );
			fhexdump(stdout, pub.n, parms.len -1);
			printf( "E  = %x\n", pub.e);
			break;

		case 'c':
			freadbyte(stdin, buf, BUFSIZ);
			ber = deber(buf);

			printf( "Serial No = %X\n", SerialNumber(ber));
			printf( "Validity \tfrom %s\n\t\tto   %s\n",
				ValidityFrom(ber), ValidityTo(ber));
			printf( "issuer:\n");
			prnname(C_IN(ber));
			printf( "subject:\n");
			prnname(C_SN(ber));
			i = Signature(ber);
			printf( "signature:\n\t%s\n", OIDstr[i]);
			i = Pubkey_AID(C_PK(ber));
			printf( "publickey:\n\talg = %s\n", OIDstr[i]);
			break;
		case 'd':
			i = freadbyte(stdin, buf, BUFSIZ);
			/* fwrite(buf, 1, i, stdout); */
			ber = deber(buf);
			dispber(ber, "\n");
			printf("\n");
			break;
		case 's':
			freadbyte(stdin, buf, BUFSIZ);
			ber = deber(buf);

			printf("%X\n", SerialNumber(ber));
			break;
		case 'h':
		default:
			fprintf(stderr, usage, argv[0]);
		}
	}
}

