/*
 * $Id: qv.c,v 1.2 1994/09/26 18:33:41 tani Exp $
 */

#define VER "version 1.10"
#define TITLE \
"Quick-VAN %s (C) 1989-1991 KAISER, TAMOYAN, paku & s.kasai\r\n \
	+unix 0.10 (C) 1991-1992 T.Matsui, tani@cs.uec.ac.jp\r\n"
  
#define MAIN
#include "qv.h"
#include "qvmsg.h"
#include <signal.h>
#include <setjmp.h>
  
  static char     FileList = 'n';

static usage()
{
  fprintf(stderr, TITLE, VER);
  fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s%s%s",
	  "Usage: qv [options] [filenames|path]\n",
	  "options are\n",
	  "-s     : Send files.    (User to host)\n",
	  "-r     : Receive files. (Host to user)\n",
	  "-b[n]  : Set Real (modem-to-modem) BPS.\n",
	  "-w[n]  : Set window size. (1..30,default 20)\n",
	  "-o     : Overwrite files if exist.\n",
	  "-a     : Append files if exist.\n",
	  "-c     : Cancel files if exist.\n",
	  "-g     : Display transfer status by graph.\n",
	  "-fDIR  : Upload & Download default directory.\n",
	  "-n     : Send start without waiting <NAK>.\n",
	  "-@     : Specify file name list.\n"
	  );
  exit(1);
}

static logdirset(dir)
	char           *dir;
{
  struct stat     Ftype;
  int             len;
  char            path[128];
  
  strcpy((char *)logdir, "");
  strcpy(path, dir);
  if (CheckPathname(path) != NORMAL)
    exit(1);
  if (debug != 'y')
    debug = 'l';
  strcpy((char *)logdir, path);
  return;
}

static udldirset(dir)
	char           *dir;
{
  struct stat     Ftype;
  int             len;
  char            path[256];
  
  strcpy((char *)udldir, "");
  strcpy(path, dir);
  if (CheckPathname(path) != NORMAL)
    exit(1);
  strcpy((char *)udldir, path);
  return;
}

static numset(s, min, max, def)
	char           *s;
	int             min;
	int             max;
	int             def;
{
  int             n;
  n = atoi(s);
  if ((n > max) || (n < min))
    n = def;
  return n;
}

static uchar    inquit = 'n';
static jmp_buf  quit_jump;
static void quit()
{
  longjmp(quit_jump, 1);
}


int  main(argc, argv)
	int	argc;
	char	*argv[];
{
  char            mode = 'r';
  int             i;
  int             err_code;
  uchar           file_name[80];
  char          **files;
  
  if (argc < 2)
    usage();	/* exit in usage() */
  {
    char  *s;
    file_name[0] = 0;
    for (i = 1; i < argc; i++) {
      s = argv[i];
      if (*s == '-') {
	s++;
	switch (tolower(*s++)) {
	  case 's':
	  mode = 's';
	  break;
	  case 'r':
	  mode = 'r';
	  break;
	  case 'w':
	  WindowSizeMax = numset(s, 1, 30, 20);
	  break;
	  case 'o':
	  FileMode = 'O';
	  break;
	  case 'a':
	  FileMode = 'A';
	  break;
	  case 'c':
	  FileMode = 'C';
	  break;
	  case 'n':
	  nopt = 1;
	  break;
	  case 'd':
	  if (*s != '-') {
	    debug = 'y';
	  } else {
	    if (debug == 'y')
	      debug = 'n';
	    s++;
	  }
	  break;
	  case 'l':
	  if (*s != '-') {
	    logdirset(s);
	  } else {
	    if (debug == 'l')
	      debug = 'n';
	    s++;
	  }
	  break;
	  case 'g':
	  if (*s != '-') {
	    gopt = 1;
	  } else {
	    gopt = 0;
	    s++;
	  }
	  break;
	  case 'f':
	  if (*s != '-') {
	    udldirset(s);
	  } else {
	    strcpy((char *)udldir, "");
	  }
	  break;
	  case '@':
	  FileList = 'y';
	  break;
	  default:
	  usage();
	}
      } else {
	while (*s == ' ')
	  s++;
	strcpy((char *)file_name, s);
	break;
      }
    }
  }
  if (cominit(&rs_bps) == 0) {
    if (setjmp(quit_jump) != 0) {
      while (txlen() != 0);
      SendCtrl(CAN);
      fprintf(stderr, "User break!\n");
      comquit();
      exit(1);
    }
    if (signal(SIGHUP, SIG_IGN) != SIG_IGN)
      signal(SIGHUP, quit);
    if (signal(SIGINT, SIG_IGN) != SIG_IGN)
      signal(SIGINT, quit);
    if (signal(SIGQUIT, SIG_IGN) != SIG_IGN)
      signal(SIGQUIT, quit);
    if (signal(SIGTERM, SIG_IGN) != SIG_IGN)
      signal(SIGTERM, quit);
    fprintf(stderr, TITLE, VER);
    fputc('\r', stderr);	/* one more linefeed */
    fputc('\n', stderr);	/* one more linefeed */
    switch (mode) {
      case 's':
      argc -= i;
      files = &argv[i];
      err_code = qv_send(argc, files);
      comput(CR);
      break;
      case 'r':
      err_code = qv_recieve(file_name[0] == 0 ? udldir : file_name);
      break;
    }
    comquit();
  } else {
    fprintf(stderr, E_ComOption);
    err_code = FATAL;
  }
  return err_code;
}

