/*
 * $Id: qv.h,v 1.3 1994/09/26 18:33:29 tani Exp tani $
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifndef  NO_STRING_H
# include <string.h>
#else
# include <strings.h>
# define	strchr	index
# define	strrchr	rindex
#endif

#ifdef luna
# include <sys/time.h>
#else
# include <time.h>
#endif

#include <ctype.h>

#define  BLOCKSIZE		128
typedef unsigned char uchar;
#if !defined(SVR4) && !defined(sony) && !defined(luna) && !defined(__liunx__)
typedef unsigned long ulong;
#endif
#if defined(__bsdi__) || defined(__FreeBSD__)
typedef unsigned int uint;
#endif

typedef struct {
  uchar Version;
  uchar RetryMethod;
  uchar WindowSIZE[2];
  uchar OptionNumber;
  uchar OptionFunc1;
  uchar Last;
}	XPARAM;

typedef struct {
  uchar Header;
  uchar Num1;
  uchar Num2;
  uchar Body[BLOCKSIZE];
  uchar ChkSum;
}       XBLOCK;


#define iowait()		{ int i; for(i=0;i<3;i++) ; }
#define SetTimer(x) 		((ulong)x * 1000L)
#define ResetTimer(x,y) 	x = ((ulong)y * 1000L)
extern ulong    gettimer();
extern int      cominit();

#define  CR		0x0d	/* $B2~9T%3!<%I(B			 */
#define  ACK		6	/* ACK				 */
#define  NAK		21	/* Negative AcK 		 */
#define  CAN		24	/* CANcel			 */
#define  SOH		1	/* Start Of Header		 */
#define  STX		2	/* Start Of Text		 */
#define  ETB		0x17	/* End Of Transfer Block	 */
#define  EOT		4	/* End Of Transmition		 */
#define  PADCHAR	0	/* PADing CHARacter 		 */
#define  VACK		'A'	/* VACK $B%V%m%C%/#i#d(B		 */
#define  VNAK		'N'	/* VNAK $B%V%m%C%/#i#d(B		 */
#define  RINIT		'R'	/* RINIT$B%V%m%C%/#i#d(B		 */
#define  VRPOS		'P'	/* VRPOS$B%V%m%C%/#i#d(B		 */
#define  SINIT		'0'	/* SINIT$B%V%m%C%/#i#d(B		 */
#define  VFILE		'1'	/* VFILE$B%V%m%C%/#i#d(B		 */
#define  VENQ		'2'	/* VENQ $B%V%m%C%/#i#d(B		 */
#define  VSTAT		'T'	/* VSTAT$B%V%m%C%/#i#d(B		 */
#define  VSKIP          'S'	/* VSKIP$B%V%m%C%/#i#d(B		 */
#define  Eof		'0'	/* $B=*N;DLCN(B			 */
#define  MaxRetry	10	
#define  InitialWaitTime   120	
#define  STimer 	   200	/* $BAw?.6I%?%$%^!<(B	  200$BIC(B */
#define  SCount 	10	/* $BAw?.:FAw2s?t(B 		 */
#define  RTimer 	20	/* $B<u?.6I%?%$%^!<(B 20$BIC(B */
#define  RCount 	10	/* $B<u?.:FAw2s?t(B 			 */
#define  TIMEOUT	-1	/* $B%?%$%`%"%&%H(B 			 */
#define  NORMAL 	 0	/* $B@5>o%3!<%I(B				 */
#define  WARNING	 1	/* $B%o!<%K%s%0(B				 */
#define  ERROR		 1	/* $B%(%i!<(B				 */
#define  FATAL		 2	/* $BCWL?E*%(%i!<(B 			 */
#define  NEXT		 3	/* $B%U%!%$%k7QB3(B 			 */
#define  SKIP            4	/* $B%U%!%$%k!&%9%-%C%W(B       */
#ifdef	 MAIN

uchar	vbuf[4 * 1024];		/* $B<u?.%U%!%$%kMQ%P%C%U%!(B	*/
uint	vbufno = 0;		/* $BAw<u?.%P%C%U%!%+%&%s%?(B	*/
uint	vbufln;			/* $B<u?.MQFI$_9~$_$7$?D9$5(B	*/

int     WindowSizeMax = 20;	/* $B%&%$%s%I%&%5%$%:(B 		*/
uchar   RetryMethod = '0';	/* $B:FAwJ}<0(B = '0' : GO BACK N	*/
uchar   SkipFunc = 'N';		/* $B%9%-%C%W5!G=$,M-8z$N;~(B = 'Y' */
int     AckRate = 0;		/* ACK$B$rJV$94V3V(B		*/
uchar   use_timer = 'v';	/* timer mode v:vsync t:normal	*/
uchar   port_no = 0;		/* Select port no.		*/
ulong   rs_bps = 0L;		/* $BE>Aw%\!<%l!<%H(B		*/
int     LastBlockNo = 0;	/* $B:G=*%V%m%C%/HV9f(B 		*/
int     StartBlockNo = 0;	/* $BE>Aw3+;O%V%m%C%/HV9f!!(B	*/
uchar   FileMode = 'R';		/* $B%U%!%$%kB8:_;~$N=hCVJ}K!(B 	*/
/* = R $BLd$$9g$o$;$k(B		*/
/* = O $B>e=q$-!!!!!!!!!!!!(B	*/
/* = A $BDI2C(B			*/

long   XferStart;		/* $BE>Aw3+;O;~9o(B 		*/
long   XferFinish;		/* $BE>Aw=*N;;~9o(B 		*/
int    XferBlock;		/* $BE>Aw40N;%V%m%C%/?t(B		*/
char   XferFile[80];		/* $BE>Aw%U%!%$%kL>(B		*/
long   XferSize;		/* $BE>Aw%U%!%$%k%P%$%H%5%$%:(B 	*/
int    XferTotalBlock;		/* $BE>AwAm%V%m%C%/?t!J:FAw$r4^$`(B)*/
int    XferRetry;		/* $B:FAw2s?t(B 			*/
int    XferFileNum;		/* $BE>Aw%U%!%$%kHV9f(B             */

uchar  debug = 'n';		/* debug mode			 */
int    gopt = 0;		/* Graphic status display option */
int    nopt = 0;		/* Send without waiting <NAK> opt */
uchar  logdir[128] = "";	/* log file directory		 */
uchar  udldir[128] = "";	/* Upl/Dnl default directory	 */

#else
extern uchar    vbuf[4 * 1024];	/* $B<u?.%U%!%$%kMQ%P%C%U%!(B	 */
extern uint     vbufno;		/* $BAw<u?.%P%C%U%!%+%&%s%?(B	 */
extern uint     vbufln;		/* $B<u?.MQFI$_9~$_$7$?D9$5(B	 */

extern int      WindowSizeMax;	/* $B%&%$%s%I%&%5%$%:(B 		 */
extern uchar    RetryMethod;	/* $B:FAwJ}<0(B = '0' : GO BACK N   */
extern uchar    SkipFunc;	/* $B%9%-%C%W5!G=$,M-8z$N;~(B = 'Y' */
extern int      AckRate;	/* ACK$B$rJV$94V3V(B		 */
extern uchar    use_timer;	/* timer mode v:vsync t:normal	 */
extern uchar    port_no;	/* Select port no.		 */
extern ulong    rs_bps;		/* $BE>Aw%\!<%l!<%H(B		 */
extern int      LastBlockNo;	/* $B:G=*%V%m%C%/HV9f(B 		 */
extern int      StartBlockNo;	/* $BE>Aw3+;O%V%m%C%/HV9f!!!!!!(B	 */
extern uchar    FileMode;	/* $B%U%!%$%kB8:_;~$N=hCVJ}K!(B 	 */

extern time_t   XferStart;	/* $BE>Aw3+;O;~9o(B 		 */
extern time_t   XferFinish;	/* $BE>Aw=*N;;~9o(B 		 */
extern int      XferBlock;	/* $BE>Aw40N;%V%m%C%/?t(B		 */
extern char     XferFile[80];	/* $BE>Aw%U%!%$%kL>(B		 */
extern long     XferSize;	/* $BE>Aw%U%!%$%k%P%$%H%5%$%:(B 	 */
extern int      XferTotalBlock;	/* $BE>AwAm%V%m%C%/?t!J:FAw$r4^$`(B) */
extern int      XferRetry;	/* $B:FAw2s?t(B 			 */
extern int      XferFileNum;	/* $BE>Aw%U%!%$%kHV9f(B             */

extern uchar    debug;		/* debug mode			 */
extern int      gopt;		/* Graphic status display option */
extern int      nopt;		/* Send without waiting <NAK> opt */
extern uchar    logdir[];	/* log file directory		 */
extern uchar    udldir[];	/* Upl/Dnl default directory	 */

#endif
/*---$B%G%P%C%0MQ(B---*/
