/*
 * $Id: qvterm.c,v 1.2 1994/09/26 18:33:41 tani Exp $
 */

#include "qv.h"
#include "qvmsg.h"

#include <varargs.h>
#include <sys/timeb.h>
#define	APPSTR	"a"
#define	RDSTR	"r"
#define	APPBSTR	"a"
#define	RDBSTR	"r"
#define	WRBSTR	"w"
#define MODBSTR	"w+"
#define	SEEK_SET	0

extern char	*getenv();

static char	fnameforutime[80];

extern	void	comRTSoff();
extern	void	comRTSon();

static char *datim()
{
  static char DateTime[32];
  struct tm	*tm;
  time_t		ti;
  
  time( &ti );
  tm = localtime( &ti );
  sprintf(DateTime,"%02d/%02d/%02d %02d:%02d:%02d",
	  (int)tm->tm_year%100,(int)tm->tm_mon+1,(int)tm->tm_mday,
	  (int)tm->tm_hour,(int)tm->tm_min,(int)tm->tm_sec);
  return(DateTime);
}

void	DispReceiveFile(fname, size, blocks)
	char *fname;
	long size;
	int blocks;
{
  fprintf(stderr,	"\nReceive File Name : %s  File Size : %ld(%d)\n",
	  fname,size,blocks );
  if ( gopt != 0 ) gopt = -1;
}

void	DispSendFile(fname, size, blocks)
	char *fname;
	long size;
	int blocks;
{
  fprintf(stderr, "\nSend File Name : %s  File Size : %ld(%d)\n",
	  fname,size,blocks );
  if ( gopt != 0 ) gopt = -1;
}

FinishLog(mode)
	char	*mode;
{
  int logttl=0;
  static char  title[] =
    "Date     Finish   File Name      Size   BPS  W  A  total   rate%    Effct NGB R";
  static char  format[] =
    "%s %-12s(%6ld)%5ld %2d %2d%7ld%3ld.%1ld(%3ld.%1ld)%3ld.%1ld%4d%2d\n";
  ulong rate,rate2,bytes,total;
  FILE *logf;
  
  CalcXferRate(XferStart,XferFinish,XferTotalBlock,&bytes,&rate2);
  CalcXferRate(XferStart,XferFinish,XferBlock,&bytes,&rate);
  total = (XferFinish - XferStart)/100L;
  fprintf(stderr, "\n%s normal end.(File:%s size:%ld rate:%3ld.%1ld%%)\n",
	  mode,XferFile,XferSize,rate/10L,rate%10L);
  if (debug=='y' || debug=='l')
    {	char	qvlog[80];
	strcpy(qvlog, (char *)logdir);
	strcat(qvlog,"qv.log");
	comRTSoff();
	logf=fopen(qvlog,RDSTR);
	if (logf==NULL) logttl=1;
	else			fclose(logf);
	logf=fopen(qvlog,APPSTR);
	if (logf!=NULL )
	  {	if (logttl) fprintf(logf,"%s\n",title);
		fprintf(logf,format,datim(),XferFile,XferSize
			,(long)rs_bps,WindowSizeMax,AckRate
			,total/10L,rate/10L ,rate%10L,rate2/10L,rate2%10L
			,bytes/10L,bytes%10L,XferTotalBlock-XferBlock,XferRetry
			);
		fclose(logf);
	      }
	comRTSon();
      }
}

CalcXferRate(start,end,block,bytes,rate)
	ulong	start;
	ulong	end;
	int 	block;	
	ulong  *bytes;
	ulong  *rate;
{
  ulong t;
  
  t=(end-start)/100L;
  if (t==0) t=1;
  *bytes =block*12800L/t;
  *rate  =(block*13200L/t)*1000L/rs_bps;
}

DisplayStatus()
{
  long	bytes	;
  long	rate	;
  ulong	nowtime , rest;
  ulong	Hour , Min , Sec;
  static char scale[] =
    "Remain time CPS Block 0---10---20---30---40---50---60---70---80---90--100(%)\n";
  
  nowtime = gettimer();
  CalcXferRate(XferStart,nowtime,XferBlock,&bytes,&rate);
  rest = (LastBlockNo-StartBlockNo+1) - XferBlock;
  rest = rest * (long)BLOCKSIZE * 10L / bytes;
  Hour = rest / 3600L;
  rest = rest - (Hour * 3600L);
  Min  = rest / 60L;
  Sec  = rest - (Min*60L);
  if ( gopt != 0 ) {
    int 	graph;
    
    if ( gopt == -1 ) {
      fprintf(stderr, scale);
      gopt = 1;
    }
    fprintf(stderr, "%02ld:%02ld:%02ld ",Hour,Min,Sec);
    fprintf(stderr, "%4ld.%ld %5d  ",bytes/10L,bytes%10L,StartBlockNo+XferBlock-1);
    graph = ((long)XferBlock*500L) / (LastBlockNo-StartBlockNo+1);
    graph = (graph + 9) / 10;
    while ( graph-- ) putc('*', stderr);
    putc('\r', stderr);
  }else{
    fprintf(stderr, " Transfer No.%d Block %ld.%1ld bytes/sec.(%ld.%1ld%%) remain(%02ld:%02ld:%02ld) retry(%d) \r"
	    ,StartBlockNo+XferBlock-1
	    ,bytes/10L,bytes%10L,rate/10L,rate%10L
	    ,Hour,Min,Sec,XferRetry);
  }
}

static	char	 fullpath[128];
static	FILE	*fp = NULL;

static	struct timestamp {
  char	 date[8];
  char	 time[6];
  char	 dumy;
}  TimeStamp;

int CheckPathname(dir)
	char   *dir;
{
  struct stat 	Ftype;
  int 		len;
  char		path[128];
  char		*env;
  
  if ( (len=strlen(dir)) == 0 ) {
    return(NORMAL);
  }
  strcpy(path,dir);
  if ( path[0] == '$' && path[len-1] == '$' )  {
    path[len-1] = '\0';
    strupr(path+1);
    if ( (env=getenv(path+1)) != NULL )  {
      strcpy(path,env);
    }
  }
  if (strcmp(path,"\\") == 0
      || (isalpha(*path) && strcmp(path+1,":") == 0)
      || (isalpha(*path) && strcmp(path+1,":\\") == 0)
      || strcmp(path,"/")  == 0
      || (isalpha(*path) && strcmp(path+1,":/")  == 0)) {
    strcpy(dir,path);
    return(NORMAL);
  }
  len = strlen(path);
  if ( path[len-1] == '\\' || path[len-1] == '/' ) path[len-1] = '\0';
  comRTSoff();
  len = stat(path,&Ftype);
  comRTSon();
  if ( len == 0 ) {
    if ( Ftype.st_mode & S_IFDIR ) {
      strcat(path,"\\");
      strcpy(dir,path);
      return(NORMAL);
    }
  }
  fprintf(stderr, E_IllPathname, dir);
  return(ERROR);
}

void SetFileInfo(Vfile)
	char	*Vfile;
{
  int 	i;
  
  XferFileNum = (*Vfile-'0') * 10 + ( *(Vfile+1)-'0');
  Vfile += 2;
  strcpy(XferFile,Vfile);
  while ( *Vfile != '\0' ) Vfile++;
  Vfile++;
  XferSize = atol(Vfile);
  while ( *Vfile != '\0' ) Vfile++;
    strncpy((char*)&TimeStamp,Vfile+1,sizeof(TimeStamp));
  TimeStamp.dumy = '\0';
  LastBlockNo = (XferSize + (BLOCKSIZE-1)) / BLOCKSIZE;
  return;
}

int OpenRecvFile(path)
	char   *path;
{
  struct stat 	st		;
  struct tm 	   *ft		;
  struct timestamp
    Ftime	;
  char			ans[80];
  long			dsize	;
  long			xsize	;
  
  strcpy(fullpath,path);
  strcat(fullpath,XferFile);
  
  dsize = XferSize - ((long)(StartBlockNo-1)*(long)BLOCKSIZE);
  /* dum */
  strcpy(fnameforutime, fullpath);
  
  comRTSoff();
  if ( stat(fullpath,&st) != 0 ) {
    ans[0] = 'O';
  }else{
    switch(FileMode) {
      case 'O' :	ans[0] = 'O'; break;
      case 'A' :	ans[0] = 'A'; break;
      case 'C' :  ans[0] = 'C'; break;
      default  :	ans[0] = 'C'; break;
    }
  }
  switch(ans[0])	{
    case 'a' :
      case 'A' :
	ft = localtime((time_t *)&st.st_atime);
	sprintf((char *)&Ftime,"%04d%02d%02d%02d%02d%02d"
		,ft->tm_year+1900,ft->tm_mon+1,ft->tm_mday
		,ft->tm_hour,ft->tm_min,ft->tm_sec);
	  StartBlockNo = (st.st_size/(long)BLOCKSIZE) + 1;
	if ( (LastBlockNo + 1) == StartBlockNo  &&
	    strcmp((char *)&Ftime, (char *)&TimeStamp) == 0  )
	  {
	    comRTSon();
	    return(ERROR);
	  }
	st.st_size = (long)(StartBlockNo - 1) * (long)BLOCKSIZE;
	if ( (fp = fopen(fullpath,MODBSTR)) == NULL ) {
	  comRTSon();
	  return(FATAL);
	}
	if ( fseek(fp,st.st_size,0) != 0 )  {
	  fclose(fp);
	  comRTSon();
	  return(FATAL);
	}
	break;
	case 'o' :
	  case 'O' :
	    StartBlockNo = 1;
	if ( (fp = fopen(fullpath,WRBSTR)) == NULL ) {
	  comRTSon();
	  return(FATAL);
	}
	break;
	case 'c' :
	  case 'C' :
	    comRTSon();
	return(ERROR);
	default :
	  comRTSon();
	return(FATAL);
      }
  
  xsize = XferSize - ((long)(StartBlockNo-1)*(long)BLOCKSIZE);
  if ( dsize < xsize ) {
    fclose(fp);
    comRTSon();
    fprintf(stderr, E_DiskSpace);
    return(FATAL);
  }
  comRTSon();
  vbufno = 0;
  return(NORMAL);
}

int WriteOneBlock(buff)
	char   *buff;
{
  memcpy( &vbuf[ vbufno * BLOCKSIZE], buff, (size_t)BLOCKSIZE);
  vbufno++;
  if ( vbufno >= (sizeof(vbuf)/BLOCKSIZE)) {
    comRTSoff();
    vbufno = 0;
    if ( fwrite(vbuf,(size_t)sizeof(char),(size_t)sizeof(vbuf),fp) == 0){
      comRTSon();
      fprintf(stderr, E_FileWrite, StartBlockNo+XferBlock+1);
      return(FATAL);
    }
    comRTSon();
  }
  return(NORMAL);
}


#define	uy(y)	(((y)%4==0&&(y)%100!=0)||(y)%400==0)

time_t	tm2time_t( tm )
	struct tm	*tm;
{
  time_t	tt;
  int		i;
  struct tm	otm, tmg;
  static int	da[] = { 31, 28, 31, 30, 31, 30,
			   31, 31, 30, 31, 30, 31 };
  
  
  for (tt = 0, i = 1900+tm->tm_year-1; i >= 1970; i--)
    tt += 86400L * ((uy(i)) ? 366 : 365);
  for (i = tm->tm_mon - 1; i >= 0; i--)
    tt += 86400L * ((i == 1) ? (uy(1900+tm->tm_year)?29:28) : da[i]);
  tt += 86400L * (tm->tm_mday - 1)
    + 3600L * tm->tm_hour + 60L * tm->tm_min + tm->tm_sec;
  memcpy( &otm, tm, sizeof( struct tm ) );
  memcpy( &tmg, gmtime( &tt ), sizeof( struct tm ) );
  tm = localtime( &tt );
  tt += otm.tm_sec - tm->tm_sec;	/* correct "uruu byo" */
  tt += (otm.tm_min - tm->tm_min) * 60L;
  tt -= (tm->tm_hour - tmg.tm_hour + 24) * 3600L;	/* correct timezone */
  return tt;
}

int CloseRecvFile()
{
  time_t	timep[2];
  struct tm	*tm;
  
  comRTSoff();
  if ( vbufno != 0 &&
      fwrite(vbuf,(size_t)sizeof(char),(size_t)(vbufno * BLOCKSIZE),fp) ==0){
    fprintf(stderr, E_FileWrite, StartBlockNo+XferBlock+1);
  }
  fclose(fp);
  time( &timep[0] );
  tm = localtime( &timep[0] );
  if ( TimeStamp.date[0] != '\0' )  {
    tm->tm_year = (TimeStamp.date[2]-'0')*10 + (TimeStamp.date[3]-'0');
    tm->tm_mon = (TimeStamp.date[4]-'0')*10 + (TimeStamp.date[5]-'0')-1;
    tm->tm_mday = (TimeStamp.date[6]-'0')*10 + (TimeStamp.date[7]-'0');
  }
  if ( TimeStamp.time[0] != '\0' )  {
    tm->tm_hour = (TimeStamp.time[0]-'0')*10 + (TimeStamp.time[1]-'0');
    tm->tm_min = (TimeStamp.time[2]-'0')*10 + (TimeStamp.time[3]-'0');
    tm->tm_sec =((TimeStamp.time[4]-'0')*10+(TimeStamp.time[5]-'0'));
  }
  timep[1] = tm2time_t( tm );
  utime(fnameforutime, timep);
  comRTSon();
}

int CheckSendFiles(n,fname)
	int 	n;
	char   *fname[];
{
  int 	i, c;
  FILE*	fp;
  
  if ( n == 0 )  {
    fprintf(stderr, E_NoSendFile);
    return(0);
  }
  for ( i = c = 0; i < n; i++ ) {
    comRTSoff();
    if ( (fp = fopen(fname[i],RDBSTR)) != NULL )	{
      fclose(fp);
      comRTSon();
      fname[c] = fname[i];
      c++;
    }else{
      comRTSon();
      fprintf(stderr, E_SendFileOpen,fname[i]);
    }
  }
  if ( c == 0 )  {
    fprintf(stderr, E_NotExistFile);
  }
  return(c);
}



int OpenSendFile(fname,xb)
	char*	fname;
	XBLOCK* xb;
{
  struct stat		st;
  struct tm		*tm;
  int 			pos 		;
  char		   *basename	;
  
  comRTSoff();
  if ( (fp = fopen(fname,RDBSTR)) != NULL )  {
    if ( (basename = strrchr(fname,'\\')) == NULL  &&
	(basename = strrchr(fname,'/')) == NULL  &&
	(basename = strrchr(fname,':')) == NULL )
      {
	basename = fname;
      }else{
	basename++;
      }
    sprintf((char *)&(xb->Body[2]),"%s",basename);
    pos = strlen(basename) + 2 + 1;
    XferSize = filelength(fileno(fp));
    sprintf((char *)&(xb->Body[pos]),"%ld",XferSize);
    pos = pos + strlen((char *)&(xb->Body[pos])) + 1;
    fstat(fileno(fp), &st);
    tm = localtime( &st.st_mtime );
    comRTSon();
    sprintf((char *)(&xb->Body[pos]),"%04d%02d%02d%02d%02d%02d",
	    (int)tm->tm_year+1900,(int)tm->tm_mon+1,(int)tm->tm_mday,
	    (int)tm->tm_hour,(int)tm->tm_min,(int)tm->tm_sec);
    LastBlockNo = (int)((XferSize+BLOCKSIZE-1)/BLOCKSIZE);
    strcpy(XferFile,basename);
    DispSendFile(XferFile,XferSize,LastBlockNo);
    vbufno = 0;
    return(LastBlockNo);
  }else{
    comRTSon();
    fprintf(stderr, E_SendFileOpen, fname);
    return(0);
  }
}




int ReadOneBlock(blockno,buff)
	int 	blockno;
	char   *buff;
{
  int 	size;
  int 	pos;
  if ( blockno >= (vbufno + (sizeof(vbuf)/BLOCKSIZE)) || blockno < vbufno
      || vbufno == 0) {
    comRTSoff();
    if ( fseek(fp,(long)(blockno - 1) * BLOCKSIZE,SEEK_SET) !=0 )  {
      comRTSon();
      fprintf(stderr, E_FileRead, blockno);
      return(0);
    }
    if ( (vbufln = fread(vbuf,sizeof(char),sizeof( vbuf),fp)) == 0) {
      comRTSon();
      fprintf(stderr, E_FileRead, blockno);
      return(0);
    }
    comRTSon();
    vbufno = blockno;
  }
  pos = (blockno - vbufno) * BLOCKSIZE;
  if ( (size = (vbufln - pos)) <= 0) {
    fprintf(stderr, E_FileRead, blockno);
    return(0);
  }else {
    if ( size > BLOCKSIZE)
      size = BLOCKSIZE;
    memcpy( buff, &vbuf[ pos], size);
  }
  return(size);
}


void	CloseSendFile()
{
  comRTSoff();
  if ( fp != NULL )  {
    fclose(fp);
    fp = NULL;
  }
  comRTSon();
  return;
}
