/*
 * $Id: qvunix.c,v 1.2 1994/09/26 18:33:41 tani Exp $
 */

#include "qv.h"
#include "qvmsg.h"
#include <sys/times.h>

#ifndef luna
# include <sys/time.h>
#endif

#include <sys/timeb.h>
#ifdef FILIO_H
# include <sys/filio.h>
#else
# include <sys/ioctl.h>
#endif

extern char    *ttyname();
extern uint     rxlen();
extern uint     txlen();

#define	TRUE	1
#define	FALSE	0

#define	RBUFSIZ		512

extern void cock2raw(), raw2cock();

int
cominit(bps)
	ulong          *bps;
{
	*bps = 9600L;
	cock2raw();
	return 0;
}

void
comquit()
{
	raw2cock();
}

#ifdef USE_TERMIO
int
comput(c)
	int             c;
{
	char            data;
	data = c;
	if (write(1, &data, 1) != 1)
		return -1;
	return 0;
}

int
comwrite(buf, size)
	uchar          *buf;
	int             size;
{
	if (write(1, buf, size) != size)
		return -1;
	return 0;
}
#else
int
comput(c)
	int             c;
{
	char            data;
	int             n;
	do {
		ioctl(0, TIOCMGET, &n);
	} while ((n & TIOCM_CTS) == 0);
	data = c;
	if (write(1, &data, 1) != 1)
		return -1;
	return 0;
}

int
comwrite(buf, size)
	uchar          *buf;
	int             size;
{
	int             n;
	while (size-- > 0) {
		n = *buf++;
		comput(n);
	}
	return 0;
}
#endif
int
comget(maxw)
	int             maxw;
{
	int             rfd;
	uchar           c;
	struct timeval  tout;
	static uchar    rbuf[RBUFSIZ];
	static int      rnum = 0;
	static int      ridx;

	if (rnum == 0) {
		tout.tv_sec = maxw / 1000;
		tout.tv_usec = maxw % 1000;

		rfd = 1 << 0;
		if ((select(1, &rfd, NULL, NULL, &tout)) == 0)
			return -1;	/* wait data with timeout */
		if ((rnum = rxlen()) > RBUFSIZ)
			rnum = RBUFSIZ;
		rnum = read(0, rbuf, rnum);
		ridx = 0;
	}
	c = rbuf[ridx++];
	if (ridx >= rnum)
		rnum = 0;
	return c;
}

ulong
gettimer()
{
	struct timeb    t;
	static ulong    base = 0;

	if (base == 0) {
		ftime(&t);
		base = t.time % 100000L * 1000 + t.millitm;
		if (base == 0)
			base = 1;
	}
	ftime(&t);
	return t.time % 100000L * 1000 + t.millitm - base;
}

uint
rxlen()
{
	long            l;

	ioctl(0, FIONREAD, &l);
	return (uint) l;
}

uint
txlen()
{
	return 0;
}

void
comRTSoff()
{
	/* nothing to do... OK? */
}

void
comRTSon()
{
	/* nothing to do... OK? */
}

void
strupr(str)
	char           *str;
{
	for (; *str; str++)
		if (islower(*str))
			*str = toupper(*str);
}

ulong
filelength(fd)
	int             fd;
{
	struct stat     st;

	if (fstat(fd, &st) == 0)
		return st.st_size;
	else
		return 0L;
}
