/*
 * $Id: tty.c,v 1.1 1994/06/22 22:04:45 tani Exp $
 */

#include <stdio.h>

#if defined(USE_TERMIO)
# include <termios.h>
#else
# include <sgtty.h>
#endif

#if defined(USE_TERMIO)
static struct termios	std, buf, buf2;
#else
static struct sgttyb	std, buf, buf2;
#endif

/*
 * raw2cock()
 * restore original terminal mode.
 */
void
raw2cock()
{
#if defined(USE_TERMIO)
    tcsetattr(0, TCSANOW, &buf);
    tcsetattr(1, TCSANOW, &buf2);
#else
    ioctl(0, TIOCSETP, &buf);
    ioctl(1, TIOCSETP, &buf2);
#endif

}

/*
 * cock2raw()
 * change original terminal mode to raw mode.
 */
#if defined(USE_TERMIO)
static void
rawmode(t)
struct termios *t;
{
    t->c_cc[VTIME] = 1;
    t->c_cc[VMIN] = 0;
    t->c_iflag &= ~(INLCR|ICRNL|ISTRIP|IXON|BRKINT|IGNCR|IXOFF);
    t->c_oflag &= ~OPOST;
    t->c_lflag &= ~(ICANON|ISIG|ECHO|ECHOE|ECHOK|ECHONL|IEXTEN);
    t->c_cflag &= ~(CSIZE|PARENB);
    t->c_cflag |= CS8;
}
#endif

void
cock2raw()
{
#if defined(USE_TERMIO)
    tcgetattr(0, &buf);
    tcgetattr(1, &buf2);

    std = buf;
    rawmode(&std);
    tcsetattr(0, TCSANOW, &std);

    std = buf2;
    rawmode(&std);
    tcsetattr(1, TCSANOW, &std);
#else
    ioctl(0, TIOCGETP, &buf);
    ioctl(1, TIOCGETP, &buf2);

    std = buf;
    std.sg_flags = RAW;
    ioctl(0, TIOCSETP, &std);
  
    std = buf2;
    std.sg_flags = RAW;
    ioctl(1, TIOCSETP, &std);
#endif
}

/* ---- end of tty.c --- */
