/*
	File transfer protocol "TransIt" Version 2.00
	BSD input/output routines.
	Copyright (C) 1992 by taka@exsys.juice.or.jp

	ΥϡҥƤ롢Transit V2.00
	ѤˡϤ˴ؤʬ򵭽ҤΤǤ

	бϡӣգΣϣӣ¤Ǥ

*/

/*
  	$Id: unixio.c,v 1.4 1994/04/27 06:44:16 tani Exp $
*/

#if !defined(SYSV_TERMIO) && !defined(USE_TERMIO) && !defined(USE_SGTTY)
# define USE_SGTTY
#endif

#if defined(USE_SGTTY) || defined(__386BSD__)
/* 386BSD and FreeBSD 1.0 completely ignore VMIN and VTIME of termios */
/* structure. */
# define SIGNAL_TIMEOUT 1
#endif

#ifdef NO_STRING_H
# include <strings.h>
# define memcpy(d,s,n) bcopy(s,d,n)
# define memmove(d,s,n) bcopy(s,d,n)
#else
# include <string.h>
#endif

#ifndef luna
# include <unistd.h>
#endif

#include "transit.h"

#ifdef FILIO_H
# include <sys/filio.h>
#else
# include <sys/ioctl.h>
#endif

#ifdef	USE_SGTTY
#include <sgtty.h>
#else
# ifdef SYSV_TERMIO
#  include <termio.h>
# else
#  include <termios.h>
# endif
#endif

#if defined(USE_TERMIO) && !defined(SYSV_TERMIO)
# define termio termios
# ifndef IUCLC
#  define IUCLC 0
# endif
#endif

#ifdef SYSV_TERMIO
# define	TCSANOW		TCSETA
# define	TCSADRAIN	TCSETAW
# define	TCSAFLUSH	TCSETAF
# define	tcgetattr(f, t)		ioctl(f, TCGETA, t)
# define	tcsetattr(f, a, t)	ioctl(f, a, t)
#endif

/* ttys setting backup structers */
#ifdef	USE_SGTTY
static struct sgttyb	tty_back;
#else
static struct termio	tty_back;
#endif

int receive=FALSE;

#if SIGNAL_TIMEOUT
static void
onalarm(sig)
     int sig; /* unused */
{
#if !(BSD >= 43)
	signal(SIGALRM, onalarm);
#endif
}
#endif

/* initailize port setting */
void rsdAttach()
{
#ifdef	USE_SGTTY
struct sgttyb	ttybtr;
	ioctl(0, TIOCEXCL, 0);
	ioctl(0, TIOCGETP, &tty_back);
	ioctl(0, TIOCGETP, &ttybtr);
	ttybtr.sg_flags &= ~(ECHO | ALLDELAY);
	ttybtr.sg_flags |= (RAW);
	ioctl(0, TIOCSETN, &ttybtr);
#else
struct termio	ttybtr;
	tcgetattr(0, &tty_back);
	ttybtr = tty_back;
	ttybtr.c_cc[VTIME] = 1;
	ttybtr.c_cc[VMIN] = 0;
	ttybtr.c_iflag &= ~(INLCR|ICRNL|IUCLC|ISTRIP|IXON|BRKINT|IGNCR|IXOFF);
	ttybtr.c_oflag &= ~OPOST;
	ttybtr.c_lflag &= ~(ICANON|ISIG|ECHO|ECHOE|ECHOK|ECHONL|IEXTEN);
	ttybtr.c_cflag &= ~(CSIZE|PARENB);
	ttybtr.c_cflag |= CS8;

	tcsetattr(0, TCSAFLUSH, &ttybtr);
#endif
#if SIGNAL_TIMEOUT
	signal(SIGALRM, onalarm);
# if BSD >= 43
	siginterrupt(SIGALRM, 1); /* Don't restart system call. */
# endif
#endif
}

/* restore setting */
void rsdDetach()
{
	/* restore ttys setting */
#ifdef	USE_SGTTY
	ioctl(0, TIOCSETN, &tty_back);
	ioctl(0, TIOCNXCL, 0);
#else
	tcsetattr(0, TCSAFLUSH, &tty_back);
#endif
}

static char readbuf[1024]; /* arbitary large number */
static int readcount; /* readbufäƤХȿ */

#ifdef __BSD_NET2__
# define READ_CHUNK 100
#else
# define READ_CHUNK 64
#endif

/* get read buffer count */
int rsdRetSize()
{
	int nget;

	if (readcount == sizeof readbuf) return sizeof readbuf;
#if SIGNAL_TIMEOUT
	alarm(1);
#endif
	if (receive)
		nget = read(0, readbuf+readcount, READ_CHUNK);
	else
		nget = read(0, readbuf+readcount, 1);
#if SIGNAL_TIMEOUT
	alarm(0);
	if (nget == -1) {
		long n;
		ioctl(0, FIONREAD, &n);
		if (n <= 0)
			nget = 0;
		else {
			if (n > (sizeof readbuf)-readcount)
				n = (sizeof readbuf)-readcount;
			nget = read(0, readbuf+readcount, n);
		}
	}
#endif
	readcount += nget;
	return readcount;
}

/* read data */
int readRsd(buf, cnt)
char	*buf;
int	cnt;
{
	if (cnt >= readcount) {
		int tmp;
		memcpy(buf, readbuf, readcount);
		tmp = readcount;
		readcount = 0;
		return tmp;
	} else {
		memcpy(buf, readbuf, cnt);
		readcount -= cnt;
		/* Memmove() can handle overlapping memory objects. */
		memmove(readbuf, readbuf+cnt, readcount);
		return cnt;
	}		
}

/* write data */
void writeRsd(buf, cnt)
char	*buf;
int	cnt;
{
	write(1, buf, cnt);
}

/* get 1-char from console */
int cgetc()
{
	/* not support.. */
	return(-1);
}
